<?php
@error_reporting (E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set ('error_reporting', E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);

@ini_set ('display_errors', true);
@ini_set ('html_errors', false);

libxml_use_internal_errors (true);

define ('ANL', true);
define ('ROOT_DIR', dirname ( __FILE__ ));
define ('ENGINE_DIR', ROOT_DIR . '/modules');
define ('CONFIG_DIR', ROOT_DIR . '/config');

session_start ();

$user_id = false;
$is_logged = false;
$cron_allow = false;
$_TIME = time ();
$module = $infomessage = "";

if (!file_exists (CONFIG_DIR . '/settings.php')) {
    header ("Location: " . str_replace ("index.php", "install.php", $_SERVER['PHP_SELF']));
    die ("Анализатор не установлен на вашем сервере. Для установки запустите файл <a href='/install.php'>install.php</a>");
}

require_once CONFIG_DIR . '/dbconfig.php';
require_once CONFIG_DIR . '/settings.php';
require_once ENGINE_DIR . '/libs/functions.php';
require_once ENGINE_DIR . '/libs/template.class.php';

$config['http_home_url'] = 'http://' . $_SERVER['HTTP_HOST'];

$template = new template (TEMPLATES_DIR);

$cron_data = @file_get_contents (CONFIG_DIR . '/cron.php');
if ($cron_data !== false) {
    $cron_data = unserialize ($cron_data);
    if (is_array ($cron_data) OR is_int ($cron_data)) $cron_time = $cron_data;
}

if (date ("Y-m-d", $cron_time) != date ("Y-m-d", $_TIME )) {
    $cron_allow = true;
    include_once ENGINE_DIR . '/cron.php';
}

if (isset ($_GET['module']) AND $_GET['module'] != "") {

    if (preg_match ( "/[\||\'|\<|\>|\[|\]|\"|\!|\?|\$|\@|\/|\\\|\&\~\*\{\+]/", $_GET['module'])) die ('Error: Access denied');
    else $module = trim (strip_tags ($_GET['module']));

}

if ($config['allow_mod_banner'] == 1) {
    require_once ENGINE_DIR . '/banners.php';
}
if ($config['last_site'] == 1) {
    require_once ENGINE_DIR . '/lastsite.php';
}
if ($config['mod_update'] == 1) {
    require_once ENGINE_DIR . '/update.php';
}

///
$template->open ('analysis_form.tpl', 'analysis_form');
$analysis_form = $template->compile ('analysis_form', true);
$template->clear ('analysis_form');
///

$metatags = array ('title' => $config['title'], 'description' => $config['description'], 'keywords' => $config['keywords']);

switch ($module) {
	case "admin" :
    	require_once ENGINE_DIR . '/admin/admin.php';
	break;

    case "static" :
        require_once ENGINE_DIR . '/static.php';
    break;

    case "last_analysis" :
        require_once ENGINE_DIR . '/last_analysis.php';
    break;

    case "tools" :
        require_once ENGINE_DIR . '/tools.php';
    break;

    case "process" :
        require_once ENGINE_DIR . '/process.php';
    break;

	default :
    	require_once ENGINE_DIR . '/analysis.php';
	break;
}

$metatags = <<<HTML
    <title>{$metatags['title']}</title>
    <meta charset="{$config['charset']}">
    <meta name="description" content="{$metatags['description']}">
    <meta name="keywords" content="{$metatags['keywords']}">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width">
    <base href="{$config['http_home_url']}">

    <!-- Javascript File -->
    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
    <script type="text/javascript" src="modules/libs/functions.js"></script>
HTML;

$template->open ('main.tpl', 'main');
$template->set ('theme', TEMPLATES_DIR, 'main');
$template->set ('metatags', $metatags, 'main');
$template->set ('content', $content, 'main');
$template->set ('info', $infomessage, 'main');
$template->set ('lastsite', $lastsite, 'main');
$template->set ('updates', $serp_upd, 'main');

$result_tools = $db->query ("SELECT `name`, `tool_url` FROM `analiz_tools` WHERE `status` = 1 ORDER BY `id`") or die ($db->error);
if ($result_tools->num_rows > 0) {
	$tools_menu = array ();

	while ($row_tools = $result_tools->fetch_assoc()) {
		$tools_menu[] = '<li><a href="/tools/' . $row_tools['tool_url'] . '/">' . $row_tools['name'] . '</a></li>';
	}

	$template->set_block ('tools', '', 'main');
	$template->set ('tools-menu', implode (" ", $tools_menu), 'main');
}

echo $template->compile ('main', true);

$template->full_clear ();
?>