<?php
define ('ANL', true);
session_start();

$version = "1.8";

//
//  Установка
//
function install () {

    $instal_error = "<p>Установка скрипта была начата не сначала. Вернитесь на главную страницу начала установки скрипта: <br><br><a href=\"http://{$_SERVER['HTTP_HOST']}/install.php\">http://{$_SERVER['HTTP_HOST']}/install.php</a></p>";

	if (!isset ($_GET['step'])) {

        $_SESSION['install'] = "start";
		start_step();

	} else {

		$step = $_GET['step'];

		switch ($step) {
			case 'test':
                if ($_SESSION['install']) server_check();
				else echo $instal_error;
            break;

			case 'chmod_check':
                if ($_SESSION['install']) chmod_check();
                else echo $instal_error;
            break;

			case 'database':
				if ($_SESSION['install']) dbconfig();
                else echo $instal_error;
            break;

			case 'admin_setup':
				if ($_SESSION['install']) admin_setup();
                else echo $instal_error;
            break;

            case 'settings':
                if ($_SESSION['install']) create_settings();
                else echo $instal_error;
            break;

			case 'license':
				if ($_SESSION['install']) license();
                else echo $instal_error;
            break;

			case 'final':
				if ($_SESSION['install']) finalstep();
                else echo $instal_error;
            break;

			default:
                $_SESSION['install'] = "start";
				start_step();
		}
	}
}

function start_step () {

	echo "<p>Добро пожаловать в мастер установки Анализатор. Данный мастер поможет вам установить скрипт всего за пару минут.</p>";
	echo "<p>Прежде чем начать установку убедитесь, что все файлы дистрибутива загружены на сервер, а также выставлены необходимые права доступа для папок и файлов.</p>";
	echo "<p><form method=get><input type='hidden' name='step' value='test'><input type='submit' value='Начать установку'></form></p>";

}

function server_check () {

	$current_dir = dirname(__FILE__);

	$phpversion = phpversion () < '5.3' ? '<span class="red"><b>' . phpversion () . '</b></span>' : '<span class="green"><b>' . phpversion () .'</b></span>';
    $mysqli_connect = function_exists('mysqli_connect') ? '<span class="green"><b>OK</b></span>' : '<span class="red"><b>NO</b></span>';
	$curl = extension_loaded ('curl') ? '<span class="green"><b>OK</b></span>' : '<span class="red"><b>NO</b></span>';
    $iconv = function_exists ('iconv') ? '<span class="green"><b>OK</b></span>' : '<span class="red"><b>NO</b></span>';
    $safe_mode = ini_get('safe_mode') ? '<span class="red"><b>ON</b></span>' : '<span class="green"><b>OFF</b></span>';
    $register_globals = ini_get('register_globals') ? '<span class="red"><b>ON</b></span>' : '<span class="green"><b>OFF</b></span>';
	$magic_quotes = ini_get('magic_quotes_runtime') ? '<span class="red"><b>ON</b></span>' : '<span class="green"><b>OFF</b></span>';
    $mbstring = extension_loaded ('mbstring') ? '<span class="green"><b>OK</b></span>' : '<span class="red"><b>NO</b></span>';
    $SimpleXML = extension_loaded ('SimpleXML') ? '<span class="green"><b>OK</b></span>' : '<span class="red"><b>NO</b></span>';
    $libxml = extension_loaded ('libxml') ? '<span class="green"><b>OK</b></span>' : '<span class="red"><b>NO</b></span>';

    echo "<p>Проверка установленных компонентов PHP</p>";
	echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">
		<tr>
			<td>PHP версия</td>
			<td>$phpversion</td>
		</tr>
		<tr>
			<td width=\"55%\">Поддержка MySQLi</td>
			<td>$mysqli_connect</td>
		</tr>
		<tr>
			<td width=\"55%\">Поддержка Curl</td>
			<td>$curl</td>
		</tr>
		<tr>
			<td width=\"55%\">Поддержка mbstring</td>
			<td>$mbstring</td>
		</tr>
		<tr>
			<td width=\"55%\">Поддержка SimpleXML</td>
			<td>$SimpleXML</td>
		</tr>
		<tr>
			<td width=\"55%\">Поддержка libxml</td>
			<td>$libxml</td>
		</tr>
		<tr>
			<td width=\"55%\">Поддержка iconv</td>
			<td>$iconv</td>
		</tr>
		<tr>
			<td width=\"55%\">Safe Mode</td>
			<td>$safe_mode</td>
		</tr>
		<tr>
			<td width=\"55%\">Magic Quotes</td>
			<td>$magic_quotes</td>
		</tr>
		<tr>
			<td width=\"55%\">Register Globals</td>
			<td>$register_globals</td>
		</tr>
        </table>";

    echo "<p class=\"info\">Если любой из этих пунктов выделен красным, то пожалуйста выполните действия для исправления положения. <br>В случае несоблюдения минимальных требований скрипта возможна его некорректная работа в системе.</p>";
	echo "<p><form method=get><input type='hidden' name='step' value='chmod_check'><input type='submit' value='Продолжить'></form></p>";

}

function chmod_check () {

    $current_dir = dirname (__FILE__);

    $important_files = array (
        './config/'
    );

    $chmod_errors = 0;
    $not_found_errors = 0;

    echo "<p>Проверка на запись у важных файлов системы</p>";
    echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">";

    foreach ($important_files as $file) {

        if (!file_exists ($file)) {
            $file_status = "<span class=\"red\">не найден!</span>";
            $not_found_errors ++;
        }elseif (is_writable ($file)) {
            $file_status = "<span class=\"green\">разрешено</span>";
        } else {
            $file_status = "<span class=\"red\">запрещено</span>";
            $chmod_errors ++;
        }

        $chmod_value = @decoct(@fileperms($file)) % 1000;

    echo "
        <tr>
            <td>$file</td>
            <td>$chmod_value</td>
            <td>$file_status</td>
        </tr>";

    }

    echo "</table>";
    echo "<p class=\"info\">$status_report</p>";

    if($chmod_errors == 0 AND $not_found_errors == 0) {
        $status_report = 'Проверка успешно завершена! Можете продолжить установку!';
    } else {
        if ($chmod_errors > 0) {
            $status_report = "<font color=\"red\">Внимание!!!</font><br> Во время проверки обнаружены ошибки: <b>$chmod_errors</b>. Запрещена запись в файл.<br> Вы должны выставить для папок CHMOD 777, для файлов CHMOD 666, используя ФТП-клиент.";
        }
        if ($not_found_errors > 0) {
            $status_report .= "<font color=\"red\">Внимание!!!</font><br />Во время проверки обнаружены ошибки: <b>$not_found_errors</b>. Файлы не найдены!";
        }
    }

    if($chmod_errors == 0 AND $not_found_errors == 0) {
	    echo "<p><form method=get><input type='hidden' name='step' value='database'><input type='submit' value='Продолжить'></form></p>";
    } else {
        echo "<p><a href='/install.php?step=chmod_check' class='button'>Обновить</a></p>";
    }
}

function dbconfig () {

	$current_dir = dirname(__FILE__);

	$dbhost = 'localhost';
	$dbname = '';
	$dbuser = '';
	$dbpassword = '';
	$error = '';

	if (isset ($_POST['dbhost']))
		$dbhost = trim (strip_tags ($_POST['dbhost']));
	if (isset ($_POST['dbname']))
		$dbname = trim (strip_tags ($_POST['dbname']));
	if (isset ($_POST['dbuser']))
		$dbuser = trim (strip_tags ($_POST['dbuser']));
	if (isset ($_POST['dbpassword']))
		$dbpassword = trim (strip_tags ($_POST['dbpassword']));

	if (!empty ($dbname) && !empty ($dbuser)) {

        $db = new mysqli ($dbhost, $dbuser, $dbpassword, $dbname);

        if ($db->connect_errno) {
            $error = 'Не могу соединиться с базой. Проверьте логин и пароль <br>' . $db->connect_error;
            exit();
        }

		if (empty ($error)) {

        # Запишем конфиги с базой

$dbconfig = "<?php
define (\"DB_HOST\", \"{$dbhost}\");
define (\"DB_NAME\", \"{$dbname}\");
define (\"DB_LOGIN\", \"{$dbuser}\");
define (\"DB_PASS\", \"{$dbpassword}\");

function display_error_mysql (\$error_num, \$error) {

echo <<<HTML
<html xmlns=\"http://www.w3.org/1999/xhtml\">
<head>
<title>MySQL Fatal Error</title>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />
<style type=\"text/css\">
body {font-family: Verdana, Arial, Helvetica, sans-serif;font-size: 12px;font-style: normal;color: #000000;}
.top {color: #ffffff;font-size: 15px;font-weight: bold;padding-left: 20px;padding-top: 10px;padding-bottom: 10px;text-shadow: 0 1px 1px rgba(0, 0, 0, 0.75);background-color: #AB2B2D;background-repeat: repeat-x;border-bottom: 1px solid #ffffff;}
.box {margin: 10px; padding: 4px; background-color: #EFEDED; border: 1px solid #DEDCDC;}
</style>
</head>
<body>
	<div style=\"width: 700px; height: auto; position: relative; left: 50%; top: 100px; margin-left: -350px; padding:20px; border:1px solid #ccc; -webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\">
		<div class=\"top\">MySQL Error!</div>
		<div class=\"box\">Error Number: <b>{\$error_num}</b></div>
		<div class=\"box\">The Error returned was:<br /> <b>{\$error}</b></div>
	</div>
</body>
</html>
HTML;

}

try {

    @\$db = new mysqli (DB_HOST, DB_LOGIN, DB_PASS, DB_NAME);

    if (\$db->connect_errno) {
        throw new Exception (display_error_mysql (\$db->connect_errno, \$db->connect_error));
    }

} catch (Exception \$e) {

    echo \$e->getMessage();
    die();

}

\$db->query (\"SET NAMES 'utf8'\");
\$db->query (\"SET CHARACTER SET 'utf8'\");
\$db->query (\"SET SESSION collation_connection = 'utf8_general_ci'\");

?>";

$con_file = fopen ($current_dir . "/config/dbconfig.php", "w+") or die ("Извините, но невозможно создать файл <b>/config/dbconfig.php</b>.<br> Проверьте правильность проставленного CHMOD!");
fwrite ($con_file, $dbconfig);
fclose ($con_file);
@chmod ($current_dir . "/config/dbconfig.php", 0666);

//////////////////////////////////////////

$table = array();

$table[] = "DROP TABLE IF EXISTS analiz_banners";
$table[] = "CREATE TABLE IF NOT EXISTS analiz_banners (
            id MEDIUMINT(8) NOT NULL auto_increment,
            tag varchar(40) NOT NULL default '',
            descr varchar(200) NOT NULL default '',
            code text NOT NULL,
            status tinyint(1) NOT NULL default 0,
            PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";

$table[] = "DROP TABLE IF EXISTS analiz_sites";
$table[] = "CREATE TABLE IF NOT EXISTS analiz_sites (
            id int(7) NOT NULL auto_increment,
            owner mediumint(8) default 0,
            url varchar(70) NOT NULL default '',
            added datetime NOT NULL default '0000-00-00 00:00:00',
            updated datetime NOT NULL default '0000-00-00 00:00:00',
  		    screenshot varchar(100) NOT NULL default 0,
            size smallint(4) UNSIGNED NOT NULL default 0,
            down_time double NOT NULL default 0,
            meta text NOT NULL default '',
            old_cy mediumint(6) NOT NULL default 0,
            new_cy mediumint(6) NOT NULL default 0,
            rang_cy smallint(1) NOT NULL default 0,
            ags smallint(1) NOT NULL default 0,
            ya_glue varchar(70) NOT NULL default '',
            yaca smallint(1) NOT NULL default 0,
            yaca_cat varchar(255) default NULL,
            yaca_descr varchar(500) default '',
            old_ya_index int(11) NOT NULL default 0,
            new_ya_index int(11) NOT NULL default 0,
            dmoz smallint(1) NOT NULL default 0,
            old_gl_index int(11) NOT NULL default 0,
            new_gl_index int(11) NOT NULL default 0,
  		    ip_site varchar(16) NOT NULL default 0,
  		    country_site varchar(100) NOT NULL default '',
  		    dc_site varchar(100) NOT NULL default '',
  		    reg_site varchar(11) NOT NULL default 0,
  		    exp_site varchar(11) NOT NULL default 0,
  		    age_site varchar(30) NOT NULL default 0,
  		    web_arch smallint(5) UNSIGNED NOT NULL default 0,
            alexa_rank varchar(200) NOT NULL default '',
            alexa_country varchar(500) NOT NULL default '',
            solomono varchar(200) NOT NULL default '',
            url_links_num varchar(50) NOT NULL default '',
            mon_srv varchar(500) NOT NULL default '',
            mon_cnt varchar(500) NOT NULL default '',
            old_mr double NOT NULL default 0,
            new_mr double NOT NULL default 0,
            status tinyint(1) NOT NULL default 0,
            PRIMARY KEY (id),
            KEY owner (owner),
            FULLTEXT KEY url (url)
)ENGINE=MyISAM DEFAULT CHARSET=utf8";

$table[] = "DROP TABLE IF EXISTS analiz_static";
$table[] = "CREATE TABLE IF NOT EXISTS analiz_static (
            id MEDIUMINT(8) NOT NULL auto_increment,
            name varchar(100) NOT NULL default '',
            descr varchar(255) NOT NULL default '',
            template text NOT NULL,
            metatitle varchar(255) NOT NULL default '',
            metadescr varchar(200) NOT NULL default '',
            metakeys text NOT NULL,
            views int(11) NOT NULL DEFAULT 0,
            status tinyint(1) NOT NULL default 1,
            PRIMARY KEY  (id),
            KEY name (name)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";

$table[] = "DROP TABLE IF EXISTS `analiz_tools`";
$table[] = "CREATE TABLE IF NOT EXISTS `analiz_tools` (
        `id` MEDIUMINT(8) NOT NULL auto_increment,
        `name` varchar(40) NOT NULL default '',
  		`title` varchar(255) NOT NULL default '',
  		`descr` varchar(255) NOT NULL default '',
  		`keywords` text NOT NULL default '',
  		`tool_url` varchar(255) NOT NULL default '',
  		`status` tinyint(1) NOT NULL default 0,
  		`captcha` tinyint(1) NOT NULL default 0,
  		`about` text NOT NULL default '',
  		`ident` varchar(10) NOT NULL default '',
        PRIMARY KEY  (`id`),
		UNIQUE KEY `tool_url` (`tool_url`),
) ENGINE=MyISAM DEFAULT CHARSET=utf8";

$table[] = "DROP TABLE IF EXISTS analiz_updserp";
$table[] = "CREATE TABLE IF NOT EXISTS analiz_updserp (
		    id int(11) NOT NULL AUTO_INCREMENT,
	        cy datetime NOT NULL default '0000-00-00 00:00:00',
	        base datetime NOT NULL default '0000-00-00 00:00:00',
	        pr datetime NOT NULL default '0000-00-00 00:00:00',
            PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";

$table[] = "DROP TABLE IF EXISTS analiz_users";
$table[] = "CREATE TABLE IF NOT EXISTS analiz_users (
		    user_id int(11) NOT NULL AUTO_INCREMENT,
		    login varchar(20) NOT NULL,
  		    password varchar(32) NOT NULL,
  		    email varchar(50) NOT NULL,
		    firstname varchar(100) NOT NULL default '',
		    surname varchar(100) NOT NULL default '',
  		    ip varchar(16) NOT NULL default '',
		    date_created int(11) NOT NULL default 0,
		    last_act int(11) NOT NULL default 0,
            PRIMARY KEY (user_id),
		    UNIQUE KEY login (login),
  		    UNIQUE KEY email (email)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";

foreach ($table as $sql) {

    $db->query ($sql) or die ($db->error);

}
///////////////////////////////////////

			echo "<p>База данных успешно настроена</p>";
			echo "<p><form method=get><input type='hidden' name='step' value='admin_setup'><input type='submit' value='Продолжить'></form></p>";
			exit ();

		}

	}

	echo "<p>Введите параметры базы данных MySQL</p>";
	if (empty ($error)) echo "<p class=\"red\"><b>Существующие данные в базе будут уничтожены!</b></p>";
	if (!empty ($error)) echo "<p class=error>$error</p>";

    echo "<form method=\"post\">
        <table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">
            <tr>
                <td>Сервер</td>
                <td><input type=text name=dbhost value='$dbhost'></td>
            </tr>
            <tr>
                <td>Имя базы</td>
                <td><input type=text name=dbname value='$dbname'></td>
            </tr>
            <tr>
                <td>Логин</td>
                <td><input type=text name=dbuser value='$dbuser'></td>
            </tr>
            <tr>
                <td>Пароль</td>
                <td><input type=text name=dbpassword value='$dbpassword'></td>
            </tr>
        </table>
        <input type='hidden' name='step' value='dbconfig'>
        <p><input type='submit' value='Продолжить'></p>
        </form>";

}

function admin_setup() {

	$current_dir = dirname(__FILE__);
    require_once $current_dir . '/config/dbconfig.php';

	if (isset ($_POST['login']) && isset ($_POST['password'])) {

        $login = $db->real_escape_string (trim (strip_tags ($_POST['login'])));
        $email = $db->real_escape_string (trim (strip_tags ($_POST['email'])));
        $password = $db->real_escape_string (trim (strip_tags ($_POST['password'])));
        $password_r = $db->real_escape_string (trim (strip_tags ($_POST['password_r'])));

        $stop = "";

    	if ($password != $password_r) $stop .= "Оба введенных пароля должны быть идентичны!<br>";
    	if (strlen ($password) < 6) $stop .= "Длина пароля должна быть не менее 6 символов и не более 16!<br>";
    	if (strlen ($login) > 20) $stop .= "Длина логина не может превышать 20 символов!<br>";
    	if (preg_match ( "/[\||\'|\<|\>|\[|\]|\"|\!|\?|\$|\@|\/|\\\|\&\~\*\{\+]/", $login)) $stop .= "Вы используете недопустимый логин!<br>";
    	if (!preg_match ('/^[-0-9a-z_\.]+@[-0-9a-z^\.]+\.[a-z]{2,4}$/i', $email) or strlen ($email) > 50) $stop .= "Введен неверный E-Mail адрес!<br>";
    	if ($login == "") $stop .= "Логин не может быть пустым!<br>";
    	if (strpos (strtolower ($login) , '.php' ) !== false) $stop .= "Вы используете недопустимый логин!<br>";

    	if (!$stop) {

    	    $password = md5 (md5 ($password));
            $date_created = time ();

    	    $sql = "INSERT INTO analiz_users (login, password, email, date_created) VALUES ('$login', '$password', '$email', $date_created)";
    	    $result = $db->query ($sql) or die ($db->error);

            echo "<p>Аккаунт администратора добавлен успешно.</p>";
    	    echo "<p><form method=get><input type='hidden' name='step' value='settings'><input type='submit' value='Продолжить'></form></p>";
            exit();

    	}

    }

	echo "<p>Регистрация администратора сайта</p>";
	if (!empty ($stop)) echo "<p class=error>$stop</p>";

    echo "<form method=\"post\">
        <table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">
            <tr>
                <td>Логин</td>
                <td><input type='text' name='login' value='".$_POST['login']."'></td>
            </tr>
            <tr>
                <td>Пароль</td>
                <td><input type='password' name='password' value='".$_POST['password']."'></td>
            </tr>
            <tr>
                <td>Пароль еще раз</td>
                <td><input type='password' name='password_r' value='".$_POST['password_r']."'></td>
            </tr>
            <tr>
                <td>E-mail</td>
                <td><input type='text' name='email' value='".$_POST['email']."'></td>
            </tr>
        </table>
        <input type='hidden' name='step' value='admin_setup'>
        <p><input type='submit' value='Продолжить'></p>
        </form>";

}

function create_settings () {
    global $version;

$settings = "<?php
\$config = array (
'title' => 'Проверка показателей сайта - инструменты для вебмастеров',
'description' => 'Проверка значений тИЦ и PR, определение позиций сайта в поисковых системах и др.',
'keywords' => 'pr, тиц, позиции в яндексе, позиции в google, анализ сайта',
'charset' => 'utf-8',
'template_name' => 'Borong',
'connect_use_proxy' => '0',
'connect_proxy' => '',
'update_time' => '24',
'mod_meta_allow' => '1',
'mod_headers_allow' => '1',
'mod_dns_allow' => '1',
'mod_listat_allow' => '1',
'mod_maj_allow' => '1',
'mod_sol_allow' => '1',
'mod_arank_allow' => '1',
'mod_country_allow' => '1',
'mod_ya_allow' => '1',
'ya_search_type' => '1',
'ya_query_login' => 'demologin',
'ya_query_key' => 'demokey',
'mod_google_allow' => '1',
'mod_whois_allow' => '1',
'mod_links_allow' => '1',
'screenshot' => '0',
'mod_monitor_allow' => '1',
'last_site' => '1',
'last_site_num' => '7',
'allow_link_result' => '1',
'allow_link_proxy' => '1',
'mod_update' => '1',
'auth_domain' => '1',
'version_id' => '{$version}',
'mod_country_type' => '1',
'mod_domain_info_allow' => '1',
'allow_mod_banner' => '1',
'moz_access_id' => '',
'moz_secret_key' => '',
'allow_updates_analysis' => '1',
);
?>";

    $current_dir = dirname (__FILE__);

    $con_file = fopen ($current_dir . "/config/settings.php", "w+") or die ("Извините, но невозможно создать файл <b>/config/settings.php</b>.<br> Проверьте правильность проставленного CHMOD!");
    fwrite ($con_file, $settings);
    fclose ($con_file);
    @chmod ($current_dir . "/config/settings.php", 0666);

    $cookie = "# Netscape HTTP Cookie File\r\n# http://curl.haxx.se/docs/http-cookies.html\r\n# This file was generated by libcurl! Edit at your own risk.\r\n";

    $con_file = fopen ($current_dir . "/config/cookie.txt", "w+") or die ("Извините, но невозможно создать файл <b>/config/cookie.txt</b>.<br> Проверьте правильность проставленного CHMOD!");
    fwrite ($con_file, $cookie);
    fclose ($con_file);
    @chmod ($current_dir . "/config/cookie.txt", 0666);

    echo "<p>Конфигурационный файл успешно создан! Для завершения установки нажмите Продолжить</p>";
    echo "<p><form method=get><input type='hidden' name='step' value='final'><input type='submit' value='Продолжить'></form></p>";
}

function finalstep() {

    global $version_id;

    //@unlink ('install.php');
    $url = 'http://' . $_SERVER['HTTP_HOST'];

	if (is_file ('install.php')) $error = 'Обязательно удалите файл install.php';

	echo "<p>Установка Анализатор завершена успешно</p>";
	echo "<p>Адрес вашего сайта: <a href='$url'>$url</a></p>";
	echo "<p>Адрес админ панели: <a href='$url/admin.php'>$url/admin.php</a></p>";
	echo "<p>Приятной работы с Анализатор!</p>";

	if (!empty ($error)) echo "<p class=error>$error</p>";

}

?>
<!DOCTYPE html>
<html lang="ru">
<head>
  <meta charset="utf-8">
  <title>Анализатор</title>
</head>
<style>
    body { margin: 0; padding: 0; font-size: 16px; color: #424242; font-family: Arial, Helvetica, sans-serif; line-height: 20px; min-height: 100%; position: relative;}
    h1, h2, h3, h4, h5, h6 {font-family: 'Cuprum', sans-serif; font-weight: normal;}
    a:link, a:active, a:visited, a:hover {color:#000;text-decoration:none;}
    h1 {font-size:26px}
    h4 {font-size:24px}
    h5 {font-size:20px}
    table {border-collapse: collapse; border: 1px dotted #D5D5D5;}
    td {padding:5px; text-align: center; border: 1px dotted #D5D5D5; font-size: 13px; color: #878787;}
    td:first-child {border-left: none;}
    tr { border: 1px dotted #e7e7e7; }
    tr:nth-child(even) {background-color:#f5f5f5;}
    p.error {color:red;}
    div.maindiv {width: 700px; height: auto; position: relative; left: 50%; top: 100px; margin-left: -350px; padding:20px; border:1px solid #ccc; -webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;}
    input[type=submit] {font-size: 14px; font-weight: bold; text-transform: uppercase; padding: 5px 14px 6px 14px; cursor: pointer; font-family: Arial, Helvetica, sans-serif; line-height: 12px;}
    input[type=text], input[type=password] {background: #fff; width: 97%; border: 1px solid #d5d5d5; padding: 5px; font-size: 13px; font-family: Arial, Helvetica, sans-serif; }
    .red { color: #ff2400; }
    .green { color: #2a8827; }
    .info {font-size: 12px;}
    .button {font-size: 14px; font-weight: bold; text-transform: uppercase; padding: 5px 14px 6px 14px; cursor: pointer; font-family: Arial, Helvetica, sans-serif; border: 1px solid #d5d5d5;}
</style>
<body>
<div style='width:100%; height:100%;'>
  <div class="maindiv">
    <h1>Анализатор</h1>
    <?php install(); ?>
  </div>
</div>
</body>
</html>