jQuery(document).ready(function($){
	/*$('form#checkurl').submit(function() {
    	return false;
	});*/

	$('input[name="url"]').keypress(function (event) {
		if (event.which == '13') {
			var func = $("input[data-type]").attr("data-type");

			$('form#' + func).submit(function() {
			    return false;
			});

			if (func == 'whois') get_whois();
			else if (func == 'headers') get_headers();
			else if (func == 'puncode') puncode();
			else if (func == 'iplocation') get_ip_location();
			else if (func == 'ipdomain') get_ip_domain();
		}
	})

	document.onkeydown = HotKeys;
	process = false;

});

function checkurl(url){
	if (process) return false;

	if(url == ""){
		$("#error").fadeIn().html('<div class="text-info-error">Имя домена не может быть пустым!</div>');
		$("input#url").focus();
		return false;
	} else {
		$("#error").fadeOut().html('');
		$("#submit").attr("disabled", true);
	}

	process = true;

	var dataString = '&action=process&url=' + url;
	url = clean_url(url);
	//history.pushState(null, null, "/analysis/" + url);
	//document.title = "Результат анализа сайта " + url;

	$("input#url").val(url);
	$("#result").hide();
	$("#page-content").html("");

	$.ajax({
		type:"POST",
		url: "/index.php?module=process",
		data: dataString,
        beforeSend: function(){
        	sec = setInterval("timer()", 100);
        	$("#result").css("display","inline").html("<div class=\"text-info\">Пожалуйста подождите идет анализ сайта " + url + "...<br><img src=\"/templates/waiting.gif\" alt=\"\"><br><span id='time'></span><br></div>");
        },
		success: function(html){
            $("#result").html(html);
            $("#result").fadeIn();
            $("#submit").text("Анализировать").attr("disabled", false);
            clearInterval(sec);
            bcounter = 0
            process = false;
        }
	});
}

var bcounter = 0;

function timer() {
	bcounter++;
	sec_value = (bcounter / 10).toFixed(1) + ' сек.';

	document.getElementById('time').innerHTML =  sec_value;
}

function clean_url (url){
	url = url.replace(/http:\/\//, "");
	url = url.replace(/https:\/\//, "");
	url = url.replace(/ftp:\/\//, "");
	//url = url.replace(/www\./, "");
	url = url.split('/');

	return url[0];
}

function HotKeys(g) {
	if (!g) {
		g = window.event;
	}
	var p = g.keyCode;

	if (g.shiftKey) {
		if (p == 13) {
			checkurl();
		}
	}
}

function changeAlexaType(self, type) {
	$('.alexaType').removeClass('here');
	$(self).addClass('here');
	var src = $('#alexaGraph').attr('src');
	src = src.replace(/&y=\w/, '&y=' + type);
	$('#alexaGraph').attr('src', src);

	return false;
}

function changeAlexaInterval(self, interval) {
	$('.alexaInterval').removeClass('here');
	$(self).addClass('here');
	var src = $('#alexaGraph').attr('src');
	src = src.replace(/&r=\d\w/, '&r=' + interval);
	$('#alexaGraph').attr('src', src);

	return false;
}

function puncode(){
	var url = $("input#url").val();

	if (url == ""){
		$("#error").fadeIn().html('<div class="text-info-error">Имя домена не может быть пустым!</div>');
		$("input#url").focus();
		return false;
	} else
		$("#error").fadeOut().html('');

	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL001&url=' + url + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#result").css("display","inline").html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        },
		success: function(res){
			if (res['status'] == 1) {
				$("#result").html('<div class="tools-response puncode">' + res['url'] + '</div>');
		    } else {
		    	$("#result").html('<div class="tools-response error">При конвертировании произошла ошибка</div>');
		    }
        }
	});
}

function get_headers(){
	var url = $("input#url").val();

	if (url == ""){
		$("#error").fadeIn().html('<div class="text-info-error">Имя домена не может быть пустым!</div>');
		$("input#url").focus();
		return false;
	} else
		$("#error").fadeOut().html('');

	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL003&url=' + url + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#result").css("display","inline").html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        },
		success: function(res){
			if (res['status'] == 1) {
				$("#result").html('<div class="tools-response headers"><table class="table">' + res['headers'] + '</div></table>');
		    } else if (res['status'] == 2) {
		    	$("#result").html(res['message']);
		    } else {
		    	$("#result").html('<div class="tools-response error">При получении заголовков произошла ошибка</div>');
		    }
        }
	});
}

function get_whois(){
	var url = $("input#url").val();

	if (url == ""){
		$("#error").fadeIn().html('<div class="text-info-error">Имя домена не может быть пустым!</div>');
		$("input#url").focus();
		return false;
	} else
		$("#error").fadeOut().html('');

	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL002&url=' + url + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#result").css("display","inline").html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        },
		success: function(res){
			if (res['status'] == 1){
				if (res['type'] == 'ip'){
					$("#result").html('<div class="tools-response whois">' + res['whois'] + '</div>');
				} else if (res['type'] == 'domain'){
					$("#result").html('<div class="tools-response whois">' + res['whois'] + '</div>');
				}
		    } else if (res['status'] == 2){
		    	$("#result").html(res['message']);
		    } else {
		    	$("#result").html('<div class="tools-response error">При получении whois информации произошла ошибка</div>');
		    }
        }
	});
}

function get_ip_location(){
	var ip = $("input#ip").val();

	if (ip == ""){
		$("#error").fadeIn().html('<div class="text-info-error">IP адрес не может быть пустым!</div>');
		$("input#ip").focus();
		return false;
	} else
		$("#error").fadeOut().html('');


	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL004&ip=' + ip + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#prepere").show().html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        	$(".tools-response").hide();
        },
		success: function(res){
			if (res['status'] == 1) {
				$("#script").html(res['map']);
				$("#prepere").hide();
				$(".tools-response").show();
		    } else if (res['status'] == 2) {
		    	$("#prepere").html(res['message']);
		    }
        }
	});
}

function get_ip_domain(){
	var url = $("input#url").val();

	if (url == ""){
		$("#error").fadeIn().html('<div class="text-info-error">Имя домена не может быть пустым!</div>');
		$("input#url").focus();
		return false;
	} else
		$("#error").fadeOut().html('');

	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL005&url=' + url + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#result").css("display","inline").html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        },
		success: function(res){
			if (res['status'] == 1) {
				$("#result").html('<div class="tools-response headers"><table class="table">' + res['ip'] + '</div></table>');
		    } else if (res['status'] == 2) {
		    	$("#result").html(res['message']);
		    } else {
		    	$("#result").html('<div class="tools-response error">При получении IP адреса произошла ошибка</div>');
		    }
        }
	});
}

function gen_meta_tags(){
	$('form#gen_meta').submit(function() {
    	return false;
	});
	$("#error, #result-block").fadeOut();

	if ($("input#metatitle").val() == ""){
		$("#error").fadeIn();
		$("#error-msg").html('<div class="text-info-error">Заголовок страницы не может быть пустым!</div>');
		$("input#metatitle").focus();
		return false;
	}
	if ($("textarea#description").val() == ""){
		$("#error").fadeIn();
		$("#error-msg").html('<div class="text-info-error">Описание страницы не может быть пустым!</div>');
		$("textarea#description").focus();
		return false;
	}

	var param = $('form#gen_meta').serialize();

	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL006&' + param + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#result-block").show();
        	$("#result").css("display","inline").html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        },
		success: function(res){
			if (res['status'] == 1) {
				$("#result").html('<label>Ваши мета теги:</label><textarea style="height:200px;" readonly>' + res['meta'] + '</textarea>');
		    } else {
		    	$("#error").fadeIn();
				$("#error-msg").html('<div class="text-info-error">' + res['message'] + '</div>');
		    	$("#result-block").hide();
		    }
        }
	});
}

function analys_metatags(){
	var url = $("input#url").val();

	$("#result-block").hide();

	if (url == ""){
		$("#error").fadeIn().html('<div class="text-info-error">Имя домена не может быть пустым!</div>');
		$("input#url").focus();
		return false;
	} else
		$("#error").fadeOut().html('');

	$.ajax({
		type:"POST",
		url: "/tools/",
		data: 'action=TL007&url=' + url + '&ident=true',
		dataType: 'json',
        beforeSend: function(){
        	$("#result-block").show();
        	$("#result").css("display","inline").html("<center><img src=\"/templates/waiting.gif\" alt=\"\"><br>Пожалуйста подождите...</center>");
        },
		success: function(res){
			if (res['status'] == 1) {
				$("#result").html('<div class="tools-response meta"><table class="table">' + res['meta'] + '</div></table>');
		    } else {
		    	$("#result").html('<div class="tools-response error">При конвертировании произошла ошибка</div>');
		    }
        }
	});
}