<?php
if (!defined ('ANL')){
	die ("Error: Access denied");
}

function get_connect ($url, $cookie = 0, $use_proxy = 0, $proxy = '') {

   	$ch = curl_init ();
	curl_setopt ($ch, CURLOPT_URL, $url);
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 0);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt ($ch, CURLOPT_ENCODING, '');
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt ($ch, CURLOPT_USERAGENT, 'Opera/9.80 (Windows NT 6.1; WOW64) Presto/2.12.388 Version/12.15');
    if ($cookie == 1) {
        curl_setopt ($ch, CURLOPT_COOKIEJAR, CONFIG_DIR . '/config/cookie.txt');
        curl_setopt ($ch, CURLOPT_COOKIEFILE, CONFIG_DIR . '/config/cookie.txt');
    }
    if ($use_proxy == 1  && $proxy != "") {
        curl_setopt ($ch, CURLOPT_PROXY, $proxy);
    }
    $result = curl_redir_exec ($ch);
    //$result = curl_exec ($ch);
    curl_close ($ch);

    return $result;
}

function curl_redir_exec ($ch) {

    $curl_loops = 0;
    $curl_max_loops = 5;

    if ($curl_loops >= $curl_max_loops) {
        $curl_loops = 0;
        return false;
    }

    curl_setopt ($ch, CURLOPT_HEADER, 1);

    $data = curl_exec ($ch);
    list ($header, $data) = explode ("\r\n\r\n", $data, 2);
    $http_code = curl_getinfo ($ch, CURLINFO_HTTP_CODE);

    if ($http_code == 301 || $http_code == 302) {

        $matches = array ();
        preg_match ('#Location: ([^\s]*)#', $header, $matches);
        $url = parse_url (trim (array_pop ($matches)));

        if (!$url) {
            $curl_loops = 0;
            return $data;
        }

        $last_url = parse_url (curl_getinfo ($ch, CURLINFO_EFFECTIVE_URL));

        if (!$url['scheme'])
            $url['scheme'] = $last_url['scheme'];
        if (!$url['host'])
            $url['host'] = $last_url['host'];
        if (!$url['path'])
            $url['path'] = $last_url['path'];
        if (!$url['query'])
            $url['query'] = $last_url['query'];

        $new_url = $url['scheme'] . '://' . $url['host'] . $url['path'] . ($url['query'] ? '?' . $url['query'] : '');

        curl_setopt ($ch, CURLOPT_URL, $new_url);
        return curl_redir_exec ($ch);

    } else {

        $curl_loops = 0;
        return $data;

    }
}

function get_screenshot ($url, $source) {
    if ($source == 0) {

        $shot = "http://mini.site-shot.com/1024x768/230/?{$url}";

    } elseif ($source == 1) {

        $shot = "http://get.thumbshots.ru/?url={$url}&w=230&h=180";

    } else {

        $shot = "http://api.thumbalizr.com/?url={$url}&width=230";

    }

    return $shot;
}

function get_web_size ($url) {

    $url = "http://" . $url;

	$start_time = start_timer ();
    $fh = @fopen ($url, "r");

    if ($fh) {

        while (($str = @fread ($fh, 1024)) != null)
            $fsize += strlen ($str);

            $kbs = @ceil ($fsize/1024);
            $res['size'] = $kbs;

    } else $res['size'] = 0;

    @fclose ($fh);
    $res['down_time'] = round (end_timer ($start_time), 2);

    return $res;
}

function get_favicon ($url) {

    $img_info = getimagesize ("http://favicon.yandex.net/favicon/" . $url);

    if ($img_info['3'] == 'width="1" height="1"') {
        return "/templates/icon_external.gif";
    } else {
        return "http://favicon.yandex.net/favicon/" . $url;
    }
}

function get_ip ($url) {

    $ip = gethostbyname ($url);

    if (preg_match('/www./i', $ip)) {

        return "Неопределено";

    } else {

        return $ip;

    }
}

function get_stat_counter ($get_content) {

    $stats = array ('analytics' => false, 'metrica' => false, 'li' => false,
                    'openstat' => false
    );

    preg_match_all ("#<script[^>]*>(.*)<\/script>#imxsU", $get_content, $script);
    $label_counter = array ('analytics' => 'google-analytics.com', 'metrica' => 'yandex.ru/metrika/', 'li' => 'counter.yadro.ru',
                            'openstat' => 'openstat.net/cnt.js'
    );

    foreach ($script[1] as $val){
        foreach ($label_counter as $k2 => $val2) {
            $pos = strpos ($val, $val2);
            if ($pos !== false) {
                $stats[$k2] = true;
            }
        }
    }

    return $stats;
}

function get_monitor_site ($header) {

    if ($header == false) return false;

    preg_match ("#HTTP/\d{1}\.\d{1} ([0-9]{3}) OK<br>#is",  $header, $http_code);
    preg_match ("#Server: (.+?)<br>#is",  $header, $server);
    preg_match ("#X-Powered-By: (.+?)<br>#is",  $header, $rowered);

    $monitor = array ();

    if ($http_code[1] == true) {
        $monitor['http_code'] = $http_code[1];
    }

    if ($server[1] == true) {
        if (strpos ($server[1], '/')) {
            $tmp = explode ("/", $server[1]);
            $server = $tmp[0];
        } else {
            $server = $server[1];
        }

        switch (mb_strtolower ($server)) {
            case 'apache':
                $monitor['server'] = array ('0' => 'apache', '1' => 'Apache');
            break;
            case 'nginx':
                $monitor['server'] = array ('0' => 'nginx', '1' => 'Nginx');
            break;
            case 'microsoft-iis':
                $monitor['server'] = array ('0' => 'microsoft', '1' => 'Microsoft-IIS');
            break;
        }
    }

    if ($rowered[1] == true) {
        if (strpos ($rowered[1], '/')) {
            $tmp = explode ("/", $rowered[1]);
            $rowered = $tmp[0];
        } else {
            $rowered = $rowered[1];
        }

        switch (mb_strtolower ($rowered)) {
            case 'php':
                $monitor['rowered'] = array ('0' => 'php', '1' => 'PHP');
            break;
            case 'asp.net':
                $monitor['rowered'] = array ('0' => 'microsoft', '1' => 'ASP.NET');
            break;
        }
    }

    return $monitor;
}

function get_head_url ($get_content) {
    if (get_url_encoding ($get_content) == "utf-8") {
        $get_content = mb_convert_encoding ($get_content, 'HTML-ENTITIES', "UTF-8");
    }

    //if (LIBXML_VERSION < 20901) {
        $get_content = preg_replace ("#<meta charset=[\"'](.+?)['\"]#i", "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=\\1\"", $get_content);
    //}

    $res = array ('title' => "", 'descr' => "", 'keywords' => "");

    $doc = new DOMDocument ('1.0', 'UTF-8');
    @$doc->loadHTML ($get_content);

    if ($doc->encoding == null) {
        $doc->encoding = "UTF-8";
    }

    $nodes = $doc->getElementsByTagName('title');
    $res['title'] = $nodes->item(0)->nodeValue;

    $metas = $doc->getElementsByTagName('meta');
    for ($i = 0; $i < $metas->length; $i++) {
        $meta = $metas->item($i);

        if (mb_strtolower ($meta->getAttribute('name')) == 'description') {
           $res['descr'] = trim ($meta->getAttribute('content'));
        }

        if (mb_strtolower ($meta->getAttribute('name')) == 'keywords') {
           $res['keywords'] = trim ($meta->getAttribute('content'));
        }
    }

    return $res;
}

function get_ya_tic ($url) {
    global $config;

    $conn_url = 'http://bar-navig.yandex.ru/u?ver=2&url=http://' . $url . '&show=1&post=0';

    $xmldoc = new SimpleXMLElement ($conn_url, NULL, TRUE);
    $site = $xmldoc->url;
    $tcy = $xmldoc->tcy;

    if (!empty ($tcy)) {

        $res['0'] = intval ($tcy['rang']);
        $res['1'] = intval ($tcy['value']);

        $bar_url = (substr ($site['domain'], 0, 4) == 'www.') ? substr ($site['domain'], 4) : $site['domain'];
        $url = (substr ($url, 0, 4) == 'www.') ? substr ($url, 4) : $url;
        $res['2'] = ($bar_url != $url) ? (string) $site['domain'] : false;

        $res['3'] = (string) $xmldoc->topics->topic['title'];
        if ($res['3']) {
        	$res['3'] = str_replace ("Тема", "Рубрика", $res['3']);
        	$res['4'] = true;
        }

        $res['5'] = ($res['0'] == 1 AND $res['1'] == 0) ? true : false;

    } else {

        $res = 0;

    }

    return $res;
}

function get_yandex_index ($url) {
	global $config;

    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);

    switch ($config['ya_search_type']) {
        case '1':
            $conn_url = 'https://yandex.ru/search/xml?user=' . $config['ya_query_login'] . '&key=' . $config['ya_query_key'] . '&query=host:' . $url . '+|+host:www.' . $url . '&l10n=ru&sortby=rlv&filter=none&groupby=attr%3D%22%22.mode%3Dflat.groups-on-page%3D10.docs-in-group%3D1';
        break;
        case '2':
            $conn_url = 'https://yandex.com/search/xml?user=' . $config['ya_query_login'] . '&key=' . $config['ya_query_key'] . '&query=host:' . $url . '+|+host:www.' . $url . '&l10n=en&sortby=rlv&filter=none&groupby=attr%3D%22%22.mode%3Dflat.groups-on-page%3D10.docs-in-group%3D1';
        break;
        case '3':
            $conn_url = 'https://yandex.com.tr/search/xml?user=' . $config['ya_query_login'] . '&key=' . $config['ya_query_key'] . '&query=host:' . $url . '+|+host:www.' . $url . '&l10n=tr&sortby=rlv&filter=none&groupby=attr%3D%22%22.mode%3Dflat.groups-on-page%3D10.docs-in-group%3D1';
        break;
    }

    $buf = get_connect ($conn_url, 0, $config['connect_use_proxy'], $config['connect_proxy']);

    if ($buf == true) {

        $xmldoc = new SimpleXMLElement ($buf);
        $result = intval ($xmldoc->response->found[2]);

    } else {

        $result = 0;

    }

  	return $result;
}

function get_minusinsk_define ($url) {
    global $config;

    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);

    switch ($config['ya_search_type']) {
        case '1':
            $conn_url = 'https://yandex.ru/search/xml?user=' . $config['ya_query_login'] . '&key=' . $config['ya_query_key'] . '&query=host:' . $url . '+|+host:www.' . $url . '&l10n=ru&sortby=rlv&filter=none&groupby=attr%3D%22%22.mode%3Dflat.groups-on-page%3D5.docs-in-group%3D1';
        break;
        case '2':
            $conn_url = 'https://yandex.com/search/xml?user=' . $config['ya_query_login'] . '&key=' . $config['ya_query_key'] . '&query=host:' . $url . '+|+host:www.' . $url . '&l10n=en&sortby=rlv&filter=none&groupby=attr%3D%22%22.mode%3Dflat.groups-on-page%3D5.docs-in-group%3D1';
        break;
        case '3':
            $conn_url = 'https://yandex.com.tr/search/xml?user=' . $config['ya_query_login'] . '&key=' . $config['ya_query_key'] . '&query=host:' . $url . '+|+host:www.' . $url . '&l10n=tr&sortby=rlv&filter=none&groupby=attr%3D%22%22.mode%3Dflat.groups-on-page%3D5.docs-in-group%3D1';
        break;
    }
}

function get_dmoz ($url) {
    global $config;

    $conn_url = "http://www.dmoz.org/search/?q=u:" . $url;
    $buf = get_connect ($conn_url, 0, $config['connect_use_proxy'], $config['connect_proxy']);

    if (preg_match ('#<a href="(?:http://|http://www\.)' . $url .'/*">.*?</a>\s*-\s*(.*?)\s*<div class="ref">#isu', $buf, $dmoz_name)) {;

       $res['0'] = 1;
       $res['1'] = $dmoz_name['1'];

    } else {

        $res['0'] = 0;

    }

     return $res;
}

function get_google_index ($url) {
    global $config;

    $conn_url = "https://www.google.com/search?hl=en&q=site:" . $url;
    $buf = get_connect ($conn_url, 1, $config['connect_use_proxy'], $config['connect_proxy']);

    if (preg_match ('#About (.+?) results#is', $buf, $match)) {

        $num = preg_replace ('#[^0-9]#', '', $match['1']);

	} else {

        $num = get_google_index_api ($url);

	}

    return $num;
}

function get_google_index_api ($url) {
    global $config;

    $conn_url = "http://ajax.googleapis.com/ajax/services/search/web?v=1.0&hl=ru&q=site:" . $url;
    $buf = get_connect ($conn_url, 1, $config['connect_use_proxy'], $config['connect_proxy']);

    $data = json_decode ($buf);

    $num = intval ($data->responseData->cursor->estimatedResultCount);

    return $num;
}

function get_ip_location ($ip) {

    $location = get_geoip_data ($ip);

    $res['country'] = strtolower ($location['country']['iso']) . "||" . $location['country']['name_ru'];
    $res['isp'] = $location['asn'];

    return $res;
}

function get_whois_info ($url) {
    include ENGINE_DIR . '/libs/servers.php';

    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);
	$first_dom = substr ($url, strpos ($url, ".") + 1);

	for ($i = 0; $i < count ($domain); $i++) {
    	if ($domain[$i][0] == $first_dom) {
            $whois = trim ($domain[$i][1]);
            $not_found_string = trim ($domain[$i][2]);
            break;
	 	}
    }

    if (empty ($whois)) return false;

    $str = '';

	$fp = @fsockopen ($whois, 43, $errno, $errstr, 30);
	@fputs ($fp, $url . "\r\n");
	while (!feof ($fp)) {
        $str .= str_replace ("\n", "<br>", fgets ($fp, 128));
    }
	@fclose ($fp);

	if (!preg_match ("/" . $not_found_string . "/is", $str)) return $str;
	else return false;
}

function get_creation_domain ($whois, $url) {
    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);

	$zone = substr ($url, strpos ($url, ".") + 1);

    if ($whois == '' OR $url == '') {

        return false;

    } else {

        if (preg_match ("#(?:Creation Date:|Created On.*?:|Created:|Registered:|Registration Date:|Registered on:|Domain Registration Date:|" .
            "Domain record activated:|Domain Created:|Domain Create Date:|Changed:)(.*?)<br>#ism", $whois, $registr)) {

            $crt = $registr[1];

            if ($zone == "ru" OR $zone == "su" OR $zone == "xn--p1ai") {

                $parts = explode (".", trim ($crt));
                $crt = ($parts[0] != 1970) ? $parts[2] . '.' . $parts[1] . '.' . $parts[0] : false;

            } elseif ($zone == "fr") {

                $parts = explode ("/", trim ($crt));
                $crt = ($parts[0] != 1970) ? $parts[1] . '.' . $parts[1] . '.' . $parts[2] : false;

            } elseif ($zone == "ua") {

                $parts = explode (" ", trim ($crt));
                $time = strtotime ($parts[0]);
                $crt = ($cntr = date ('Y', $time) != 1970) ? date ('d.m.Y', $time) : false;

            } elseif ($zone == "kz") {

                $parts = explode (" ", trim ($crt));
                $time = strtotime ($parts[0]);
                $crt = ($cntr = date ('Y', $time) != 1970) ? date ('d.m.Y', $time) : false;

            } else {

                $time = strtotime ($crt);
                $crt = ($cntr = date ('Y', $time) != 1970) ? date ('d.m.Y', $time) : false;

            }

            return $crt;

        }

        return false;
    }
}

function get_expiration_domain ($whois, $url) {
    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);

	$zone = substr ($url, strpos ($url, ".") + 1);

    if ($whois == '' OR $url == '') {

        return false;

    } else {

        if (preg_match ("#(?:Expiration Date:|Expires:|Expiry date:|Domain Expiration Date:|Domain expires:|expire:|Expire Date:|paid-till:|" .
            "Expires on.*:|Domain Currently Expires:|status:\s*OK-UNTIL)(.*?)<br>#ism", $whois, $expires)) {

            $exp = $expires[1];

            if ($zone == "ru" OR $zone == "su" OR $zone == "xn--p1ai") {

                $parts = explode (".", trim ($exp));
                $exp = ($parts[0] != 1970) ? $parts[2] . '.' . $parts[1] . '.' . $parts[0] : false;

            } else {

                $time = strtotime ($exp);
                $exp = ($cntr = date ('Y', $time) != 1970) ? date ('d.m.Y', $time) : false;

            }

            return $exp;

        }

        return false;
    }
}

function get_age_domain ($date_creation, $date_expiration) {
    $st = explode ('-', date ('d-m-Y-H-i-s', $date_creation));
    $fin = explode ('-', date ('d-m-Y-H-i-s', $date_expiration));

    if (($seconds = $fin[5] - $st[5]) < 0) {
        $fin[4]--;
        $seconds += 60;
    }

    if (($minutes = $fin[4] - $st[4]) < 0) {
        $fin[3]--;
        $minutes += 60;
    }

    if (($hours = $fin[3] - $st[3]) < 0) {
        $fin[0]--;
        $hours += 24;
    }

    if (($days = $fin[0] - $st[0]) < 0) {
        $fin[1]--;
        $days = date ('t', mktime (1, 0, 0, $st[1], $st[0], $st[2])) - $st[0] + $fin[0];
    }

    if (($months = $fin[1] - $st[1]) < 0) {
        $fin[2]--;
        $months += 12;
    }

    $years = $fin[2] - $st[2];

    $period = array (
        'days' => $days . " " . num2word ($days, array ("день", "дня", "дней")),
        'months' => $months . " " . num2word ($months, array ("месяц", "месяца", "месяцев")),
        'years' => $years . " " . num2word ($years, array ("год", "года", "лет"))
    );

    if (!$years AND !$months AND !$days) {
        return false;
    }

    if ($years > 40) {
        return false;
    }

    if (!$years AND !$months) {
        return $period['days'];
    }

    if (!$years AND $months) {
        return $period['months'] . " " . $period['days'];
    }

    if ($years AND !$months AND $days) {
        return $period['years'] . " " . $period['days'];
    }

    if ($years AND $months AND $days) {
        return $period['years'] . " " .  $period['months'] . " " . $period['days'];
    }

    //return array ($seconds, $minutes, $hours, $days, $months, $years);
}

function get_li_stat ($url) {
    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);

    $lines = file ("http://counter.yadro.ru/values?site=" . $url);
	$info = array ();

	foreach ($lines as $line) {

		if (preg_match ("#LI_error#", $line, $stat)) {
            $info = 0;
		} else {
            preg_match ("|LI_([^ ]+) = (\d*);|", $line, $stat);
            $info[$stat[1]] = $stat[2];
		}

	}

	return $info;
}

function get_web_archive ($url) {
    global $config;

    $conn_url = "http://web.archive.org/web/*/http://" . $url;
    //$conn_url = "http://web.archive.bibalex.org/web/*/http://" . $url;
    $buf = get_connect ($conn_url, 0, $config['connect_use_proxy'], $config['connect_proxy']);

	if (preg_match ('#<p>Saved <strong>(.*?)</strong>#is', $buf, $match)) {
	//if (preg_match ('/<p align="right"><b>(\d+)<\/b> Results<\/p>/i', $buf, $match)) {
        $num = preg_replace ('#[^0-9]#', '', $match['1']);

    } else {

       $num = 0;

    }

    return $num;
}

function get_header ($url) {
    $lines = @get_headers ('http://' . $url);

    $res = false;

    if (is_array ($lines)) {
    	foreach ($lines as $line) {
            $res .= $line . "<br>";
    	}
    }

    return $res;
}

function get_alexa_rank ($url) {
    global $config;

    $conn_url = 'http://data.alexa.com/data?cli=10&dat=snbamz&url=' . $url;

    try {
        $xmldoc = new SimpleXMLElement ($conn_url, NULL, TRUE);

        if ($xmldoc->SD[1]->REACH) {
        	$rank_reach = $xmldoc->SD[1]->REACH;
            $rank_reach = intval ($rank_reach->attributes()->RANK);
        }  else {
            $rank_reach = 0;
        }

        if ($xmldoc->SD[1]->POPULARITY) {
        	$rank = $xmldoc->SD[1]->POPULARITY;
            $alexa_rank = intval ($rank->attributes()->TEXT);
        }  else {
            $alexa_rank = 0;
        }

        if ($xmldoc->SD[1]->COUNTRY) {
        	$country = $xmldoc->SD[1]->COUNTRY;
        	$country_rank = array (strtolower ($country->attributes()->CODE), (string) $country->attributes()->NAME, (string) $country->attributes()->RANK);
        }  else {
            $country_code = 0;
        }

        $res[0] = $alexa_rank;
        $res[1] = $rank_reach;
        $res[2] = $country_rank;

    } catch (Exception $e) {

    	$res = array (0, 0, 0);

    }

    return $res;
}

function get_solomono ($url) {
    global $config;

    try {
        $conn_url = 'http://xml.linkpad.ru/?url=http://' . $url;

        $xmldoc = new SimpleXMLElement ($conn_url, NULL, TRUE);
        $res = array ();
        $res['index'] = (string) $xmldoc->index;

        if ($res['index'] == 0) {

            $res = 0;

        } else {

            $res['mr'] = (string) $xmldoc->mr;
            $res['ip'] = (string) $xmldoc->ip;
            $res['dout'] = (string) $xmldoc->dout;
            $res['anchors'] = (string) $xmldoc->anchors;
            $res['anchors_out'] = (string) $xmldoc->anchors_out;
            $res['igood'] = (string) $xmldoc->igood;
            $res['hin'] = (string) $xmldoc->hin;
            $res['din'] = (string) $xmldoc->din;
            $res['hout'] = (string) $xmldoc->hout;

            unset ($res['index']);

        }

    } catch (Exception $e) {

        $res = 0;

    }

    return $res;
}

function get_site_links ($get_content, $urldomain) {

    if (substr ($url, 0, 4) == 'www.') $urldomain = substr ($url, 4);
    if (get_url_encoding ($get_content) == "utf-8") $get_content = mb_convert_encoding ($get_content, 'HTML-ENTITIES', "UTF-8");

    $doc = new DOMDocument ('1.0', 'UTF-8');
    @$doc->loadHTML ($get_content);
    $urls = $doc->getElementsByTagName('a');
    $num = 0;

    foreach ($urls as $url) {
        if ($url->getAttribute('href') == "" OR $url->getAttribute('href') == "#" OR $url->getAttribute('onclick')) continue;

        if (preg_match ('#(?:https?|www|ftp|mailto)#is', trim ($url->getAttribute('href')))) {

            if (!preg_match ("#^(?:https?:\/\/|www\.|https?:\/\/www\.){1}(?:$urldomain){1}#is", trim ($url->getAttribute('href')))){
                $link['ext'][$num][0] = trim ($url->getAttribute('href'));
                $link['ext'][$num][1] = htmlspecialchars (trim ($url->textContent));
                if ($url->hasAttribute('rel') == 'nofollow') {
                    $link['ext'][$num][2] = trim ($url->getAttribute('rel'));
                }
            } else {
                $link['int'][$num][0] = trim ($url->getAttribute('href'));
                $link['int'][$num][1] = htmlspecialchars (trim ($url->textContent));
                if ($url->hasAttribute('rel') == 'nofollow') {
                    $link['ext'][$num][2] = trim ($url->getAttribute('rel'));
                }
            }

        } else {

            if (preg_match ("#^/#is", trim ($url->getAttribute('href')))) {
                $link['int'][$num][0] = "http://" . $urldomain . trim ($url->getAttribute('href'));
            } else {
                $link['int'][$num][0] = "http://" . $urldomain . "/" . trim ($url->getAttribute('href'));
            }

            $link['int'][$num][1] = htmlspecialchars (trim ($url->textContent));
            if ($url->hasAttribute('rel') == 'nofollow') {
                $link['ext'][$num][2] = trim ($url->getAttribute('rel'));
            }

        }

        $num ++;
    }

    return $link;
}

function get_top_country_alexa ($url) {

    if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);

    $doc = new DomDocument;
    @$doc->loadHTMLFile ('http://www.alexa.com/siteinfo/' . $url);
    $data = @$doc->getElementById ('demographics_div_country_table');
    $my_data = $data->getElementsByTagName ('tr');

    $check_data = true;
    $countries = array ();

    foreach ($my_data as $node) {
        foreach ($node->getElementsByTagName ('a') as $href) {
            preg_match ('/([0-9\.\%]+)/', $node->nodeValue, $match);
            $code = strtolower (substr ($href->getAttribute('href'), -2));

            if ($href->nodeValue == ' sign up and get certified') {
                $check_data = false;
            } else {
                $country = str_replace (chr (194) . chr (160), "", $href->nodeValue);
                $countries[] = array ('code' => $code, 'country' => $country, 'percent' => $match[0]);

            }
        }
    }

    return (empty ($countries)) ? false: $countries;
}

function page_get_headers ($crawl_uri) {
    $headers = get_headers ($crawl_uri, 1);
    if (empty ($headers)) {
        return array ();
    }

    $splitmarks = array ();
    foreach ($headers as $key => $h) {
        if (is_numeric ($key)) {
            array_push ($splitmarks, $h);
        }
    }

    $headers_final = array ();
    $i = 0;
    $headers = get_headers($crawl_uri);
    foreach ($headers as $head) {
        if (array_key_exists ($i, $splitmarks) && $head === $splitmarks[$i]) {

            $headers_final[$i]['Http-Code'] = $splitmarks[$i];
            $i++;

        } else {

            $tmp = explode (": ", $head, 2);
            if (!empty ($headers_final[$i-1][$tmp[0]])) {
                if (is_array ($headers_final[$i-1][$tmp[0]])) {
                    array_push ($headers_final[$i-1][$tmp[0]], $tmp[1]);
                } else {
                    $headers_final[$i-1][$tmp[0]] = array ($headers_final[$i-1][$tmp[0]], $tmp[1]);
                }
            } else {
                $headers_final[$i-1][$tmp[0]] = $tmp[1];
            }
        }
    }

    return $headers_final;
}

function get_ip_whois ($ip) {
    $whoisservers = array (
        //"whois.afrinic.net",
        "whois.lacnic.net",
        "whois.apnic.net",
        "whois.arin.net",
        "whois.ripe.net"
    );

    $results = array ();
    foreach ($whoisservers as $whoisserver) {
        $fp = @fsockopen ($whoisserver, 43, $errno, $errstr, 10) or die ("Socket Error " . $errno . " - " . $errstr);

        fputs ($fp, $ip . "\r\n");
        $out = "";
        while (!feof ($fp)) {
            $out .= fgets ($fp);
        }
        fclose ($fp);

        $result = "";
        if ((strpos (strtolower ($out), "error") === FALSE) && (strpos (strtolower ($out), "not allocated") === FALSE)) {
            $rows = explode ("\n", $out);
            foreach ($rows as $row) {
                $row = trim ($row);
                if (($row != '') && ($row{0} != '#') && ($row{0} != '%')) {
                    $result .= $row . "<br>";
                }
            }
        }

        if ($result && !in_array ($result, $results)) {
            $results[$whoisserver]= $result;
        }
    }

    $res = "НАЙДЕНО РЕЗУЛЬТАТОВ: " . count ($results);
    foreach ($results as $whoisserver => $result) {
        $res .= "<br><br>-------------<br>Lookup results for " . $ip . " from " . $whoisserver . " server:<br><br>" . $result;
    }

    return $res;
}

function get_geoip_data ($ip) {

    $location = array ();

    require_once ENGINE_DIR . '/libs/sxgeo.class.php';
    $sx_geo_city = new SxGeo (ROOT_DIR . '/bases/SxGeoCity.dat');
    $location = $sx_geo_city->getCityFull ($ip);

    require_once ENGINE_DIR . '/libs/geoip.inc';
    $giasn = geoip_open (ROOT_DIR . "/bases/GeoIPASNum.dat", GEOIP_STANDARD);
    $asn = geoip_org_by_addr ($giasn, $ip);
    $location['asn'] = preg_replace ("(AS\d*)", "", $asn);
    geoip_close ($giasn);

    return $location;
}

function message_box ($title, $text, $type) {
	global $config;

	if (!class_exists ('template')) {
	    echo "template eror";
	}

	$template = new template (TEMPLATES_DIR);
	$template->open ('/info.tpl', 'info');
    $template->set ('theme', TEMPLATES_DIR, 'info');
	$template->set ('text', $text, 'info');
	$template->set ('title', $title, 'info');
    if ($type == 1) $template->set_block ('error', '', 'info');
    if ($type == 2) $template->set_block ('success', '', 'info');
	$content = $template->compile ('info', true);

    return $content;
}

function check_url ($url) {
    global $config;

    include ENGINE_DIR . '/libs/servers.php';
    if (is_array ($domain)) {
        $allow_domain = "";
        foreach ($domain as $key=>$value) {
            foreach ($value as $key2=>$zone) {
                if ($key2 == 0 AND strlen ($zone) > 2) {
                    if ($zone == "xn--p1ai") $zone = str_replace ("xn--p1ai", "рф", $zone);
                    if (strrpos ($zone, ".") == true) continue;
                    $allow_domain .= $zone . "|";
                }
            }
        }
    }

	$url = trim ($url);
	if (strlen ($url) == 0) return 1;

    $charset = strtolower ($config['charset']);
    if ($charset == "utf-8") $utf_pref = "u"; else $utf_pref = "";

	if (!preg_match ("~^(?:(?:https?|ftp|telnet)://(?:[а-яёa-z0-9_-]{1,32}(?::[а-яёa-z0-9_-]{1,32})?@)?)?(?:(?:[а-яёa-z0-9-]{1,128}\.)+(?:" .
    $allow_domain . "[a-z]{2})|(?!0)(?:(?!0[^.]|255)[0-9]{1,3}\.){3}(?!0|255)[0-9]{1,3})(?:/[а-яёa-z0-9.,_@%&?+=\~/-]*)?(?:#[^ '\"&<>]*)?$~i{$utf_pref}", $url, $ok))
	return -1;

	if (!strstr ($url,"://")) $url = "http://".$url;
	$url = preg_replace ("~^[a-z]+~i{$utf_pref}e","strtolower('\\0')", $url);
	return $url;
}

function check_type ($url) {
    global $config;

    include ENGINE_DIR . '/libs/servers.php';
    if (is_array ($domain)) {
        $allow_domain = "";
        foreach ($domain as $key=>$value) {
            foreach ($value as $key2=>$zone) {
                if ($key2 == 0 AND strlen ($zone) > 2) {
                    if ($zone == "xn--p1ai") $zone = str_replace ("xn--p1ai", "рф", $zone);
                    if (strrpos ($zone, ".") == true) continue;
                    $allow_domain .= $zone . "|";
                }
            }
        }
    }

    $charset = strtolower ($config['charset']);
    if ($charset == "utf-8") $utf_pref = "u"; else $utf_pref = "";

	if (preg_match ("~^(?:(?:https?|ftp|telnet)://(?:[а-яё0-9_-]{1,32}(?::[а-яё0-9_-]{1,32})?@)?)?(?:(?:[а-яё0-9-]{1,128}\.)+(?:" .
	$allow_domain . "[a-z]{2})|(?!0)(?:(?!0[^.]|255)[0-9]{1,3}\.){3}(?!0|255)[0-9]{1,3})(?:/[а-яa-z0-9.,_@%&?+=\~/-]*)?(?:#[^ '\"&<>]*)?$~i{$utf_pref}", $url, $ok))
	return 1;

    elseif (preg_match ("~^(?:(?:https?|ftp|telnet)://(?:[a-z0-9_-]{1,32}(?::[a-z0-9_-]{1,32})?@)?)?(?:(?:[a-z0-9-]{1,128}\.)+(?:" .
	$allow_domain . "[a-z]{2})|(?!0)(?:(?!0[^.]|255)[0-9]{1,3}\.){3}(?!0|255)[0-9]{1,3})(?:/[a-z0-9.,_@%&?+=\~/-]*)?(?:#[^ '\"&<>]*)?$~i{$utf_pref}", $url, $ok))
   	return 0;

   	else return 0;
}

function punycode ($url) {
    require_once ENGINE_DIR.'/libs/idna_convert.class.php';

    $IDN = new idna_convert;
    return $IDN->encode ($url);
}

function clean_url ($url) {

	if ($url == '') return;

	$url = str_replace ("http://", "", mb_strtolower ($url, "UTF-8"));
	$url = str_replace ("https://", "", $url);
	//if (substr ($url, 0, 4) == 'www.') $url = substr ($url, 4);
	$url = explode ('/', $url);
	$url = reset ($url);
	$url = explode (':', $url);
	$url = reset ($url);

	return $url;
}

function get_url_encoding ($str) {
    $cp_list = array ('utf-8', 'windows-1251');
    foreach ($cp_list as $k => $codepage){
        if (md5 ($str) === md5 (iconv ($codepage, $codepage, $str))){
            return $codepage;
        }
    }
    return null;
}

function DateRus ($dt, $time = false) {

    $rus_month = array (1 => "января", 2 => "февраля", 3 => "марта", 4 => "апреля", 5 => "мая", 6 => "июня", 7 => "июля", 8 => "августа", 9 => "сентября", 10 => "октября", 11 => "ноября", 12 => "декабря");

    $today = date ('j.n.Y', time ());
    $yesterday = date ('j.n.Y', time () - 86400);
    $tomorrow = date ('j.n.Y', time () + 86400);
    $cur_day = date ('j.n.Y', $dt);
    $cur_time = date ('H:i', $dt);

    switch ($cur_day) {
        case $tomorrow :
            $output = 'завтра в ' . $cur_time;
        break;
        case $today :
            $output = 'сегодня в ' . $cur_time;
        break;
        case $yesterday :
            $output = 'вчера в ' . $cur_time;
        break;
        default :
            $hours = "";

            if ($time == true) {
                $hours = explode (":", $cur_time);
                $hours = " в " . $hours[0] . ":" . $hours[1];
            }

            $date = explode (".", $cur_day);
            $output = $date[0] . " " . $rus_month[$date[1]] . " " . $date[2] . $hours;
        break;
    }

    return $output;
}

function pagination ($total_page, $page, $module, $type) {
    if ($total_page >= 8) {
        if ($page < 3) {
         	$x = 1;
         	$y = $x + 4;
        } elseif ($page >= 3 && $page < $total_page-1) {
         	$x = $page - 2;
         	$y = $x + 4;
         } elseif ($page <= $total_page) {
         	$x = $total_page - 4;
         	$y = $total_page;
        }
    } else {
        $x = 1;
        $y = $total_page;
    }

    if ($y > 1) {
        if ($page == 1) $paginator .= " &larr; ";
        else $paginator .= "<a href='/$type.php?module=$module'> &larr; </a>";

        for ($x; $x <= $y; $x ++) {
            if ($page == $x) $paginator .= "<om> " . $x . " </om>";
            else $paginator .= "<a href='/$type.php?module=$module&page=$x'> " . $x . " </a>";
        }

        if ($page == $total_page) $paginator .= "&rarr;";
        else $paginator .= "<a href='/$type.php?module=$module&page=$total_page'> &rarr; </a>";
    }

    return $paginator;
}

function get_rand_str ($salt=10) {
    $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPRQSTUVWXYZ0123456789";
    $code = "";
    $clen = strlen ($chars) - 1;

    while (strlen ($code) < $salt) {
    	$code .= $chars[mt_rand (0, $clen)];
    }

    return $code;
}

function set_cookie ($name, $value, $expires) {

	if ($expires) {

		$expires = time() + ($expires * 86400);

	} else {

		$expires = FALSE;

	}

	if (PHP_VERSION < 5.2) {

		if (DOMAIN) setcookie ($name, $value, $expires, "/", "; HttpOnly");
		else setcookie ($name, $value, $expires, "/", DOMAIN . "; HttpOnly");

	} else {

		setcookie ($name, $value, $expires, "/", DOMAIN, NULL, TRUE);

	}
}

function get_time () {
    list ($usec, $seconds) = explode (" ", microtime ());
    return ((float) $usec + (float) $seconds);
}

function start_timer () {
    return get_time ();
}

function end_timer ($start_time) {
    return (get_time () - $start_time);
}

function translit ($str) {
    $converter = array(
         'а' => 'a',   'б' => 'b',   'в' => 'v',
         'г' => 'g',   'д' => 'd',   'е' => 'e',
         'ё' => 'e',   'ж' => 'zh',  'з' => 'z',
         'и' => 'i',   'й' => 'y',   'к' => 'k',
         'л' => 'l',   'м' => 'm',   'н' => 'n',
         'о' => 'o',   'п' => 'p',   'р' => 'r',
         'с' => 's',   'т' => 't',   'у' => 'u',
         'ф' => 'f',   'х' => 'h',   'ц' => 'c',
         'ч' => 'ch',  'ш' => 'sh',  'щ' => 'sch',
         'ь' => '',    'ы' => 'y',   'ъ' => '',
         'э' => 'e',   'ю' => 'yu',  'я' => 'ya',

         'А' => 'A',   'Б' => 'B',   'В' => 'V',
         'Г' => 'G',   'Д' => 'D',   'Е' => 'E',
         'Ё' => 'E',   'Ж' => 'Zh',  'З' => 'Z',
         'И' => 'I',   'Й' => 'Y',   'К' => 'K',
         'Л' => 'L',   'М' => 'M',   'Н' => 'N',
         'О' => 'O',   'П' => 'P',   'Р' => 'R',
         'С' => 'S',   'Т' => 'T',   'У' => 'U',
         'Ф' => 'F',   'Х' => 'H',   'Ц' => 'C',
         'Ч' => 'Ch',  'Ш' => 'Sh',  'Щ' => 'Sch',
         'Ь' => '',    'Ы' => 'Y',   'Ъ' => '',
         'Э' => 'E',   'Ю' => 'Yu',  'Я' => 'Ya',
    );

    $str = strtr ($str, $converter);
    $str = trim ($str, "-");
    $str = strtolower ($str);
    $str = preg_replace ('#[^-a-z0-9_]+#is', '-', $str);

    return $str;
}

function clear_form_text ($text, $tags_replace = false, $charset = "UTF-8") {
    global $db;

    $text = trim ($text);
    $text = ($tags_replace == true) ? htmlentities ($text, ENT_QUOTES, $charset) : strip_tags ($text);
    $text = $db->real_escape_string ($text);

    return $text;
}

function getRealIpAddr () {
    if (!empty ($_SERVER['HTTP_CLIENT_IP'])) {

        $ip = $_SERVER['HTTP_CLIENT_IP'];

    } elseif (!empty ($_SERVER['HTTP_X_FORWARDED_FOR'])) {

        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];

    } else {

        $ip = $_SERVER['REMOTE_ADDR'];

    }

    return $ip;
}

function validate_ip ($ip) {
    $ipnums = explode (".", $ip);
    if (count($ipnums) != 4) {
        return false;
    }
    foreach ($ipnums as $ipnum) {
        if (!is_numeric ($ipnum) || ($ipnum > 255)) {
            return false;
        }
    }
    return $ip;
}

function num2word ($n, $titles) {
    $cases = array (2, 0, 1, 1, 1, 2);
    return $titles[($n % 100 > 4 && $n % 100 < 20) ? 2 : $cases[min($n % 10, 5)]];
}

function between_dates ($datenow, $todate) {
    $datetime1 = date_create (date ("Y-m-d", $datenow));
    $datetime2 = date_create (date ("Y-m-d", $todate));
    $interval  = date_diff ($datetime2, $datetime1);

    $days = array (1 => $interval->format('%a'), 2 => $interval->days . " " . num2word ($interval->days, array ('день', 'дня', 'дней')));

    return $days;
}

function admin_pagination ($pag_set) {

    $table = "";
    $patch = $pag_set['patch'];
    $cur_page = $pag_set['cur_page'];
    $previous_btn = $pag_set['previous_btn'];
    $next_btn = $pag_set['next_btn'];
    $first_btn = $pag_set['first_btn'];
    $last_btn = $pag_set['last_btn'];
    $no_of_paginations = $pag_set['no_of_paginations'];

    if ($cur_page >= 10) {
        $start_loop = $cur_page - 3;
        if ($no_of_paginations > $cur_page + 3) {
            $end_loop = $cur_page + 3;
        } else if ($cur_page <= $no_of_paginations && $cur_page > $no_of_paginations - 6) {
            $start_loop = $no_of_paginations - 6;
            $end_loop = $no_of_paginations;
        } else {
            $end_loop = $no_of_paginations;
        }
    } else {
        $start_loop = 1;
        if ($no_of_paginations > 10)
            $end_loop = 10;
        else
            $end_loop = $no_of_paginations;
    }

    if ($no_of_paginations > 1) {
        $table .= "<ul class=\"pagination\">";
        if ($first_btn && $cur_page > 1) {
            $table .= "<li><a href='/admin.php?module={$patch}&page=1'>&laquo;</a></li>";
        } else if ($first_btn) {
            $table .= "<li class=\"noactive\"><span>&laquo;</span></li>";
        }

        if ($previous_btn && $cur_page > 1) {
            $pre = $cur_page - 1;
            $table .= "<li><a href='/admin.php?module={$patch}&page={$pre}'>&larr;</a></li>";
        } else if ($previous_btn) {
            $table .= "<li class=\"noactive\"><span>&larr;</span></i>";
        }

        for ($i = $start_loop; $i <= $end_loop; $i++) {
            if ($cur_page == $i)
                $table .= "<li class=\"active\"><span>{$i}</span></li>";
            else
                $table .= "<li><a href='/admin.php?module={$patch}&page={$i}'>{$i}</a></li>";
        }

        if ($next_btn && $cur_page < $no_of_paginations) {
            $next = $cur_page + 1;
            $table .= "<li><a href='/admin.php?module={$patch}&page={$next}'>&rarr;</a></li>";
        } else if ($next_btn) {
            $table .= "<li class=\"noactive\"><span>&rarr;</span></li>";
        }

        if ($last_btn && $cur_page < $no_of_paginations) {
            $table .= "<li><a href='/admin.php?module={$patch}&page={$no_of_paginations}'>&raquo;</li>";
        } else if ($last_btn) {
            $table .= "<li class=\"noactive\"><span>&raquo;</span></li>";
        }
        $table .= "</ul>";
    }

    return $table;
}

function get_moz_rank ($url) {
    global $config;

    $expires = time() + 300;
    $str_to_sign = $config['moz_access_id'] . "\n" . $expires;
    $signature = urlencode (base64_encode (hash_hmac ('sha1', $str_to_sign, $config['moz_secret_key'], true)));

    $conn_url = "http://lsapi.seomoz.com/linkscape/url-metrics/" . urlencode ($url) . "?Cols=16384&AccessID=" . $config['moz_access_id'] . "&Expires=" . $expires . "&Signature=" . $signature;
    $buf = get_connect ($conn_url, 0, $config['connect_use_proxy'], $config['connect_proxy']);

    $data = json_decode ($buf);
    $rank = round ($data->umrp, 2);

    return $rank;
}

function get_semrush_rank ($url) {
	global $config;

	$conn_url = 'http://us.backend.semrush.com/?action=report&type=domain_rank&domain=' . $url;
	$buf = get_connect ($conn_url, 0, $config['connect_use_proxy'], $config['connect_proxy']);

	$data = json_decode ($buf);
	$rank = $data->rank->data->{0}->Rk;

	return $rank;
}

?>