<?php
if (!defined ('ANL')){
    die ("Access denied!");
}

if (isset ($_POST['action']) AND $_POST['action'] == "process") {
    try {
        $update = $config['update_time'] * 60 * 60;
        $_RESULT = array ();
        $is_exists = false;
        $is_connect = false;

        $_POST['url'] = trim (strip_tags ($_POST['url']));
        $_RESULT['site'] = clean_url ($_POST['url']);

        if (strlen ($_RESULT['site']) > 40) {
            throw new Exception ("Слишком длинное доменное имя!");
        }
        if (!$_RESULT['site']) {
            throw new Exception ("Адрес сайта имеет не допустимое значение!");
        }
        if (check_url ($_RESULT['site']) == -1) {
            throw new Exception ("Имя домена имеет не допустимое значение!");
        }

        $_RESULT['domain'] = (substr ($_RESULT['site'], 0, 4) == 'www.') ? substr ($_RESULT['site'], 4) : $_RESULT['site'];

        $sql = "SELECT url, updated, screenshot, size, down_time, meta, old_cy, new_cy, rang_cy, ags, ya_glue, yaca, yaca_cat, yaca_descr, old_ya_index, new_ya_index, dmoz, old_gl_index, new_gl_index, ip_site, country_site,
                dc_site, reg_site, exp_site, age_site, web_arch, alexa_rank, alexa_country, solomono, url_links_num, mon_srv, mon_cnt, old_mr, new_mr, status
                FROM analiz_sites
                WHERE url = '{$_RESULT['domain']}'";
        $result = $db->query ($sql) or die ($db->error);
        $row = $result->fetch_assoc ();
        $result->free ();

        if ($row['status'] == 1) {
            throw new Exception ("Домен " . $_RESULT['site'] . " занесен в черный список, Вы не можете проверить его!");
        }

        if (check_type ($_RESULT['site']) == 1) {
            $_RESULT['site'] = punycode ($_RESULT['site']);
        }

        $subdomain = explode (".", $_RESULT['site']);

        //Start
        if (!$row['updated'] OR (strtotime ($row['updated']) + $update) < $_TIME) {

            $_RESULT['title_text'] = "Анализ сайта {$_RESULT['site']}";
            $_RESULT['check_type'] = "analysis";

            $_RESULT['whois'] = get_whois_info ($_RESULT['site']);
            if (!$_RESULT['whois'] AND count ($subdomain) == 2) {
                throw new Exception ("Домен " . $_RESULT['site'] . " не зарегистрирован в данный момент, Вы не можете проверить его!");
            }

            $response = get_connect ("http://" . $_RESULT['site'], 0, $config['connect_use_proxy'], $config['connect_proxy']);
            if (!$response) {
                throw new Exception ("Домен " . $_RESULT['site'] . " не доступен в данный момент, Вы не можете проверить его!");
            }

            $is_connect = true;
            $is_exists = true;

            if ($config['mod_listat_allow'] == 1) {
                $_RESULT['listat'] = json_encode (get_li_stat ($_RESULT['site']));
            }

            if ($config['mod_headers_allow'] == 1) {
                if ($is_connect == true) {
                    $_RESULT['headers'] = get_header ($_RESULT['site']);
                }
            }

            if ($config['mod_dns_allow'] == 1) {
                $_RESULT['dns'] = ($is_connect == true) ? json_encode (@dns_get_record ($_RESULT['site'], DNS_ALL)) : false;
            }

            $_RESULT['last_update'] = DateRus ($_TIME, true);
            $_RESULT['next_update'] = DateRus ($_TIME + $update, true);
            $_RESULT['added'] = date ("Y-m-d H:i:s", $_TIME);

            $_RESULT['screenshot'] = get_screenshot ($_RESULT['site'], $config['screenshot']);

            $res = get_web_size ($_RESULT['site']);
            $_RESULT['size'] = $res['size'];
            $_RESULT['down_time'] = $res['down_time'];

            if ($config['mod_meta_allow'] == 1) {
                if ($is_connect == true) {
                    $res = get_head_url ($response);
                } else {
                    $res = array ('title' => "", 'descr' => "", 'keywords' => "");
                }
                $res['favicon'] = get_favicon ($_RESULT['site']);

                $_RESULT['meta'] = implode ("|||", $res);
            }

            if ($config['mod_ya_allow'] == 1) {
                $res = get_ya_tic ($_RESULT['site']);
                $_RESULT['ya_rang'] = $res['0'];
                $_RESULT['ya_glue'] = $res['2'];

                $_RESULT['ya_current_tic'] = $res['1'];
                $_RESULT['ya_last_tic'] = ($_RESULT['ya_current_tic'] != $row['new_cy']) ? $row['new_cy'] : $row['old_cy'];
                $_RESULT['ya_diff_tic'] = $_RESULT['ya_current_tic'] - $_RESULT['ya_last_tic'];

                $_RESULT['ya_cat_allow'] = $res['4'];
                $_RESULT['ya_cat_category'] = $res['3'];
                $_RESULT['ya_ags'] = $res['5'];

                $_RESULT['ya_current_index'] = get_yandex_index ($_RESULT['site']);
                $_RESULT['ya_last_index'] = ($_RESULT['ya_current_index'] != $row['new_ya_index']) ? $row['new_ya_index'] : $row['old_ya_index'];
                $_RESULT['ya_diff_index'] = $_RESULT['ya_current_index'] - $_RESULT['ya_last_index'];
            }

            if ($config['mod_google_allow'] == 1) {
                $_RESULT['moz_current_rank'] = get_moz_rank ($_RESULT['site']);
                $_RESULT['moz_last_rank'] = ($_RESULT['moz_current_rank'] != $row['new_mr']) ? $row['new_mr'] : $row['old_mr'];
                $_RESULT['moz_diff_rank'] = $_RESULT['moz_current_rank'] - $_RESULT['moz_last_rank'];

                $res = get_dmoz ($_RESULT['site']);
                $_RESULT['dmoz_allow'] = $res['0'];
                $_RESULT['dmoz_name'] = $res['1'];

                $_RESULT['google_current_index'] = get_google_index ($_RESULT['site']);
                $_RESULT['google_last_index'] = ($_RESULT['google_current_index'] != $row['new_gl_index']) ? $row['new_gl_index'] : $row['old_gl_index'];
                $_RESULT['google_diff_index'] = $_RESULT['google_current_index'] - $_RESULT['google_last_index'];
            }

            if ($config['mod_domain_info_allow'] == 1) {
                $_RESULT['ip_domain'] = get_ip ($_RESULT['site']);

                $res = get_ip_location ($_RESULT['ip_domain']);
                $_RESULT['ip_isp'] = $res['isp'];
                $_RESULT['ip_country'] = $res['country'];

                $_RESULT['domain_creation'] = get_creation_domain ($_RESULT['whois'], $_RESULT['site']);
                $_RESULT['domain_exp'] = get_expiration_domain ($_RESULT['whois'], $_RESULT['site']);
                $_RESULT['domain_age'] = get_age_domain (strtotime ($_RESULT['domain_creation']), strtotime (date ("d-m-Y")));

                $_RESULT['web_archive'] = get_web_archive ($_RESULT['site']);
            }

            if ($config['mod_arank_allow'] == 1) {
                $get_alexa_rank = get_alexa_rank ($_RESULT['site']);
                $_RESULT['alexa_rank'] = json_encode ($get_alexa_rank);
            }

            if ($config['mod_sol_allow'] == 1) {
                $res = get_solomono ($_RESULT['site']);
                $_RESULT['solomomo'] = ($res != 0) ? implode ("||", $res) : 0;
            }

            if ($config['mod_links_allow'] == 1) {
                $res_site_links = get_site_links ($response, $_RESULT['site']);

                $int_num = 0;
                $ext_num = 0;

                if (is_array ($res_site_links)) {

                    $link_int = "";
                    $link_ext = "";
                    $int_num_rel = 0;
                    $ext_num_rel = 0;

                    foreach ($res_site_links as $link_key => $link_value) {
                        foreach ($link_value as $type) {
                            if ($type[1] == "") $type[1] = "<Нет анкора>";

                            if ($link_key == "int") {
                                $link_int .= $type[1] . "<br><span class=\"link-site-green\">" . $type[0] . "</span><br>";
                            } elseif ($link_key == "ext") {
                                $link_ext .= $type[1] . "<br><span class=\"link-site-green\">" . $type[0] . "</span><br>";
                            }

                            if ($link_key == "int" AND $type[2] == "nofollow") {
                                $int_num_rel ++;
                            } elseif ($link_key == "ext" AND $type[2] == "nofollow") {
                                $ext_num_rel ++;
                            }
                        }
                    }

                    $int_num = count ($res_site_links['int']);
                    $ext_num = count ($res_site_links['ext']);

                }

                $_RESULT['site_links_num'] = ($int_num == 0 AND $ext_num == 0) ? false : json_encode (array ('int' => $int_num, 'int-rel' => $int_num_rel, 'ext' => $ext_num, 'ext-rel' => $ext_num_rel));
            }

            if ($config['mod_monitor_allow'] == 1) {
                $stat_counter = get_stat_counter ($response);
                $_RESULT['monitor_counter'] = json_encode ($stat_counter);

                $server = get_monitor_site ($_RESULT['headers']);
                $_RESULT['monitor_server'] = ($server == false) ? false : json_encode ($server);
            }

            if ($config['mod_country_allow'] == 1) {
                $get_top_country_alexa = get_top_country_alexa ($_RESULT['site']);
                $_RESULT['country_alexa'] = ($get_top_country_alexa == false) ? false : json_encode ($get_top_country_alexa);
            }

            $_SQL_RESULT = array ();
            foreach ($_RESULT as $k => $val) {
                $_SQL_RESULT[$k] = clear_form_text ($val);
            }

            if (!$row['updated']) {
                $sql = "INSERT INTO analiz_sites (
                            url, added, updated, screenshot, size,
                            down_time, meta, old_cy, new_cy, rang_cy,
                            ags, ya_glue, yaca, yaca_cat, yaca_descr,
                            old_ya_index, new_ya_index, dmoz, old_gl_index, new_gl_index,
                            ip_site, country_site, dc_site, reg_site, exp_site,
                            age_site, web_arch, alexa_rank, alexa_country, solomono,
                            url_links_num, mon_srv, mon_cnt, old_mr, new_mr
                        )
                        VALUES (
                            '{$_SQL_RESULT['domain']}', '{$_SQL_RESULT['added']}', '{$_SQL_RESULT['added']}', '{$_SQL_RESULT['screenshot']}', '{$_SQL_RESULT['size']}',
                            '{$_SQL_RESULT['down_time']}', '{$_SQL_RESULT['meta']}', '{$_SQL_RESULT['ya_current_tic']}', '{$_SQL_RESULT['ya_current_tic']}', '{$_SQL_RESULT['ya_rang']}',
                            '{$_SQL_RESULT['ya_ags']}', '{$_SQL_RESULT['ya_glue']}', '{$_SQL_RESULT['ya_cat_allow']}', '{$_SQL_RESULT['ya_cat_category']}', '{$_SQL_RESULT['ya_cat_descr']}',
                            '{$_SQL_RESULT['ya_last_index']}', '{$_SQL_RESULT['ya_current_index']}', '{$_SQL_RESULT['dmoz_allow']}', '{$_SQL_RESULT['google_last_index']}', '{$_SQL_RESULT['google_current_index']}',
                            '{$_SQL_RESULT['ip_domain']}', '{$_SQL_RESULT['ip_country']}', '{$_SQL_RESULT['ip_isp']}', '{$_SQL_RESULT['domain_creation']}', '{$_SQL_RESULT['domain_exp']}',
                            '{$_SQL_RESULT['domain_age']}', '{$_SQL_RESULT['web_archive']}', '{$_SQL_RESULT['alexa_rank']}', '{$_SQL_RESULT['country_alexa']}', '{$_SQL_RESULT['solomomo']}',
                            '{$_SQL_RESULT['site_links_num']}', '{$_SQL_RESULT['monitor_server']}', '{$_SQL_RESULT['monitor_counter']}', '{$_SQL_RESULT['moz_current_rank']}', '{$_SQL_RESULT['moz_current_rank']}'
                        )";
            }

            if ($row['updated'] AND (strtotime ($row['updated']) + $update) < $_TIME) {
                $sql = "UPDATE
                            analiz_sites
                        SET
                            updated = '{$_SQL_RESULT['added']}',
                            screenshot = '{$_SQL_RESULT['screenshot']}',
                            size = '{$_SQL_RESULT['size']}',
                            down_time = '{$_SQL_RESULT['down_time']}',
                            meta = '{$_SQL_RESULT['meta']}',
                            old_cy = '{$_SQL_RESULT['ya_last_tic']}',
                            new_cy = '{$_SQL_RESULT['ya_current_tic']}',
                            rang_cy = '{$_SQL_RESULT['ya_rang']}',
                            ags = '{$_SQL_RESULT['ya_ags']}',
                            ya_glue = '{$_SQL_RESULT['ya_glue']}',
                            yaca = '{$_SQL_RESULT['ya_cat_allow']}',
                            old_ya_index = '{$_SQL_RESULT['ya_last_index']}',
                            new_ya_index = '{$_SQL_RESULT['ya_current_index']}',
                            dmoz = '{$_SQL_RESULT['dmoz_allow']}',
                            old_gl_index = '{$_SQL_RESULT['google_last_index']}',
                            new_gl_index = '{$_SQL_RESULT['google_current_index']}',
                            ip_site = '{$_SQL_RESULT['ip_domain']}',
                            country_site = '{$_SQL_RESULT['ip_country']}',
                            dc_site = '{$_SQL_RESULT['ip_isp']}',
                            reg_site = '{$_SQL_RESULT['domain_creation']}',
                            exp_site = '{$_SQL_RESULT['domain_exp']}',
                            age_site = '{$_SQL_RESULT['domain_age']}',
                            web_arch = '{$_SQL_RESULT['web_archive']}',
                            alexa_rank = '{$_SQL_RESULT['alexa_rank']}',
                            alexa_country = '{$_SQL_RESULT['country_alexa']}',
                            solomono = '{$_SQL_RESULT['solomomo']}',
                            url_links_num = '{$_SQL_RESULT['site_links_num']}',
                            mon_srv = '{$_SQL_RESULT['monitor_server']}',
                            mon_cnt = '{$_SQL_RESULT['monitor_counter']}',
                            old_mr = '{$row['moz_last_rank']}',
                            new_mr = '{$_SQL_RESULT['moz_current_rank']}'
                        WHERE
                            url = '{$_SQL_RESULT['domain']}'";
            }

            $result = $db->query ($sql) or die ($db->error);
            unset ($_SQL_RESULT);

        } else {

            $_RESULT['last_update'] = DateRus (strtotime ($row['updated']), true);
            $_RESULT['next_update'] = DateRus (strtotime ($row['updated']) + $update, true);

            $_RESULT['title_text'] = "Результат анализа сайта {$_RESULT['site']} от {$_RESULT['last_update']}";
            $_RESULT['check_type'] = "result";

            $_RESULT['screenshot'] = $row['screenshot'];
            $_RESULT['size'] = $row['size'];
            $_RESULT['down_time'] = $row['down_time'];
            $_RESULT['meta'] = $row['meta'];

            $_RESULT['ya_rang'] = $row['rang_cy'];
            $_RESULT['ya_current_tic'] = $row['new_cy'];
            $_RESULT['ya_last_tic'] = $row['old_cy'];
            $_RESULT['ya_diff_tic'] = $_RESULT['ya_current_tic'] - $_RESULT['ya_last_tic'];
            $_RESULT['ya_glue'] = $row['ya_glue'];
            $_RESULT['ya_cat_allow'] = $row['yaca'];
            $_RESULT['ya_cat_category'] = $row['yaca_cat'];
            $_RESULT['ya_cat_descr'] = $row['yaca_descr'];
            $_RESULT['ya_ags'] = $row['ags'];
            $_RESULT['ya_current_index'] = $row['new_ya_index'];
            $_RESULT['ya_last_index'] = $row['old_ya_index'];
            $_RESULT['ya_diff_index'] = $_RESULT['ya_current_index'] - $_RESULT['ya_last_index'];

            $_RESULT['moz_current_rank'] = $row['new_mr'];
            $_RESULT['moz_last_rank'] = $row['old_mr'];
            $_RESULT['moz_diff_rank'] = $_RESULT['moz_current_rank'] - $_RESULT['moz_last_rank'];
            $_RESULT['dmoz_allow'] = $row['dmoz'];
            $_RESULT['google_current_index'] = $row['new_gl_index'];
            $_RESULT['google_last_index'] = $row['old_gl_index'];
            $_RESULT['google_diff_index'] = $_RESULT['google_current_index'] - $_RESULT['google_last_index'];

            $_RESULT['ip_domain'] = $row['ip_site'];
            $_RESULT['ip_isp'] = $row['dc_site'];
            $_RESULT['ip_country'] = $row['country_site'];
            $_RESULT['domain_creation'] = $row['reg_site'];
            $_RESULT['domain_exp'] = $row['exp_site'];
            $_RESULT['domain_age'] = $row['age_site'];
            $_RESULT['web_archive'] = $row['web_arch'];

            $_RESULT['alexa_rank'] = $row['alexa_rank'];

            $_RESULT['solomomo'] = $row['solomono'];

            $_RESULT['site_links_num'] = $row['url_links_num'];

            $_RESULT['monitor_counter'] = $row['mon_cnt'];
            $_RESULT['monitor_server'] = $row['mon_srv'];

            $_RESULT['country_alexa'] = $row['alexa_country'];

        }

        $check_type = ($_RESULT['check_type'] == "analysis") ? "analysis" : "result";

        $template->open ('result.tpl', 'analysis');
        $template->set ('theme', TEMPLATES_DIR, 'analysis');
        $template->set ('site-link', ($config['allow_link_proxy'] == 1) ? $config['http_home_url'] . "/go.php?url=http://" . $_RESULT['domain'] : "http://" . $_RESULT['domain'], 'analysis');
        $template->set ('site-url', $_RESULT['domain'], 'analysis');
        $template->set ('screen-url', $_RESULT['screenshot'], 'analysis');
        $template->set ('size', $_RESULT['size'], 'analysis');
        $template->set ('down-time', $_RESULT['down_time'], 'analysis');
        $template->set ('title-text', $_RESULT['title_text'], 'analysis');
        $template->set_block ($check_type, '', 'analysis');

        $scripts = array ();

        if ($config['mod_meta_allow'] == 1) {
            $res_meta = explode ("|||", $_RESULT['meta']);

            $title = ($res_meta[0] != false) ? $res_meta[0] : '<i>Не найдено название в метатегах</i>';
            $descr = ($res_meta[1] != false) ? str_replace (",", ", ", $res_meta[1]) : '<i>Не найдено описание в метатегах</i>';;
            $keyswords = ($res_meta[2] != false) ? "Ключевые слова: " . str_replace (",", ", ", $res_meta[2]) : "";
            $favicon = $res_meta['3'];

            $template->set_block ('meta-tags', '', 'analysis');
            $template->set ('title', $title, 'analysis');
            $template->set ('favicon-url', $favicon, 'analysis');
            $template->set ('description', $descr, 'analysis');
            $template->set ('keyswords', $keyswords, 'analysis');
            $template->set ('last-update', $_RESULT['last_update'], 'analysis');
            $template->set ('next-update', $_RESULT['next_update'], 'analysis');
        }

        if ($config['mod_ya_allow'] == 1) {
            if ($_RESULT['ya_cat_allow'] == true) {
                $yaca = '<a href="https://yandex.ru/yaca/?text=' . $_RESULT['domain'] .'" target="_blank" rel="tooltip" original-title="' . $_RESULT['ya_cat_category'] . '" class="green">Да</a>';
            } else {
                $yaca = '<a href="https://yandex.ru/yaca/?text=' . $_RESULT['domain'] .'" target="_blank" class="red">Нет</a>';
            }

            $ya_ags = ($_RESULT['ya_ags'] == true) ? '<span class="red">АГС</span>' : '<span class="green">Нет</span>';
            $ya_glue = ($_RESULT['ya_glue'] == false) ? '<span class="green" rel="tooltip" original-title="Яндекс не считает домен (тИЦ) склееным">Нет</span>' : '<span class="red" rel="tooltip" original-title="Яндекс считает домен склееным (тИЦ) с ' . $_RESULT['ya_glue'] . '">Да</span>';

            if ($_RESULT['ya_diff_index'] != 0) {
                $ya_diff_index = (strpos ($_RESULT['ya_diff_index'], '-') !== false) ? "<span class=\"diff-text red\">-{$_RESULT['ya_diff_index']}</span>" : "<span class=\"diff-text green\">+{$_RESULT['ya_diff_index']}</span>";
            }
            if ($_RESULT['ya_diff_tic'] != 0) {
                $ya_diff_tic = (strpos ($_RESULT['ya_diff_tic'], '-') !== false) ? "<span class=\"diff-text red\">-{$_RESULT['ya_diff_tic']}</span>" : "<span class=\"diff-text green\">+{$_RESULT['ya_diff_tic']}</span>";
            }

            $template->set_block ('yandex', '', 'analysis');
            $template->set ('tic-rang', "bar" . $_RESULT['ya_rang'], 'analysis');
            $template->set ('ya-tic', $_RESULT['ya_current_tic'] . " " . $ya_diff_tic, 'analysis');
            $template->set ('yaca', $yaca, 'analysis');
            $template->set ('sanctions', $ya_ags, 'analysis');
            $template->set ('yaglue', $ya_glue, 'analysis');
            $template->set ('ya-index', $_RESULT['ya_current_index'] . " " . $ya_diff_index, 'analysis');
        }

        if ($config['mod_google_allow'] == 1) {
            if ($_RESULT['dmoz_allow'] == 1) {
                $dmoz = '<a href="http://dmoz.org/search/?q=u:' . $_RESULT['domain'] . ' "target="_blank" class="green">Да</a>';
            } else {
                $dmoz = '<a href="http://dmoz.org/search/?q=u:' . $_RESULT['domain'] . ' "target="_blank" class="red">Нет</a>';
            }

            if ($_RESULT['google_diff_index'] != 0) {
                $gl_diff_index = (strpos ($_RESULT['google_diff_index'], '-') !== false) ? "<span class=\"diff-text red\">-{$_RESULT['google_diff_index']}</span>" : "<span class=\"diff-text green\">+{$_RESULT['google_diff_index']}</span>";
            }
            if ($_RESULT['moz_diff_rank'] != 0) {
                $moz_diff_rank = (strpos ($_RESULT['moz_diff_rank'], '-') !== false) ? "<span class=\"diff-text red\">-{$_RESULT['moz_diff_rank']}</span>" : "<span class=\"diff-text green\">+{$_RESULT['moz_diff_rank']}</span>";
            }

            $template->set_block ('google', '', 'analysis');
            $template->set ('moz-rank', $_RESULT['moz_current_rank'] . " " . $moz_diff_rank, 'analysis');
            $template->set ('dmoz', $dmoz, 'analysis');
            $template->set ('google-index', $_RESULT['google_current_index'] . " " . $gl_diff_index, 'analysis');
        }

        if ($config['mod_domain_info_allow'] == 1) {
            if ($_RESULT['ip_country'] != false) {
                $res_country = explode ("||", $_RESULT['ip_country']);
                $country = '<img src="templates/' . $config['template_name'] . '/img/flags/' . $res_country['0'] . '.png" alt="" style="vertical-align:baseline"> ' . $res_country['1'];
            } else {
                $country = "Нет данных";
            }

            $domain_creation = ($_RESULT['domain_creation'] != false) ? $_RESULT['domain_creation'] : "Нет данных";
            $domain_exp = ($_RESULT['domain_exp'] != false) ? $_RESULT['domain_exp'] : "Нет данных";
            $domain_age = ($_RESULT['domain_age'] != false) ? $_RESULT['domain_age'] : "Нет данных";
            $domain_ip = ($_RESULT['ip_isp'] != false) ? $_RESULT['ip_isp'] : "Нет данных";

            if ($_RESULT['web_archive'] != 0) {
                $domain_wa = '<a href="http://web.archive.org/web/*/http://' . $_RESULT['domain'] . '" target="_blank" class="green">Да, ' . $_RESULT['web_archive'] . '</a>';
            } else {
                $domain_wa = '<a href="http://web.archive.org/web/*/http://' . $_RESULT['domain'] . '" target="_blank" class="red">Нет</a>';
            }

            $template->set_block ('domain-info', '', 'analysis');
            $template->set ('site-ip', $_RESULT['ip_domain'], 'analysis');
            $template->set ('isp', $domain_ip, 'analysis');
            $template->set ('country', $country, 'analysis');
            $template->set ('domain-creation', $domain_creation, 'analysis');
            $template->set ('domain-exp', $domain_exp, 'analysis');
            $template->set ('domain-age', $domain_age, 'analysis');
            $template->set ('domain-wa', $domain_wa, 'analysis');
        }

        if ($config['mod_whois_allow'] == 1 AND $_RESULT['whois'] != false) {
            $template->set_block ('whois-info', '', 'analysis');
            $template->set ('whois', $_RESULT['whois'], 'analysis');
        }

        if ($config['mod_listat_allow'] == 1 AND !empty ($_RESULT['listat'])) {
            $res_li_stat = json_decode ($_RESULT['listat'], true);

            $template->set_block ('live-internet', '', 'analysis');
            $template->set ('li-month-hit', $res_li_stat['month_hit'], 'analysis');
            $template->set ('li-month-vis', $res_li_stat['month_vis'], 'analysis');
            $template->set ('li-week-hit', $res_li_stat['week_hit'], 'analysis');
            $template->set ('li-week-vis', $res_li_stat['week_vis'], 'analysis');
            $template->set ('li-day-hit', $res_li_stat['day_hit'], 'analysis');
            $template->set ('li-day-vis', $res_li_stat['day_vis'], 'analysis');
        }

        if ($config['mod_arank_allow'] == 1) {
        	$alexa_rank = json_decode ($_RESULT['alexa_rank'], true);
        	$rank_country = (!empty ($alexa_rank[2])) ? '<img src="templates/' . $config['template_name'] . '/img/flags/' . $alexa_rank[2][0] . '.png" alt=""> ' . $alexa_rank[2][1] . ' ' . $alexa_rank[2][2] : "Нет данных";

            $template->set_block ('alexa', '', 'analysis');
            $template->set ('alexa-rank', $alexa_rank[0], 'analysis');
            $template->set ('alexa-rep', $alexa_rank[1], 'analysis');
            $template->set ('alexa-rank-country', $rank_country, 'analysis');
            $template->set ('alexa-site-url', ($_RESULT['site']) ? $_RESULT['site'] : $_RESULT['domain'], 'analysis');
        }

        if ($config['mod_sol_allow'] == 1 AND $_RESULT['solomomo'] != "0") {
            $res_solomono = explode ("||", $_RESULT['solomomo']);

            $template->set_block ('linkpad', '', 'analysis');
            $template->set ('solomomo-mr', $res_solomono['0'], 'analysis');
            $template->set ('solomomo-ip', $res_solomono['1'], 'analysis');
            $template->set ('solomomo-dout', $res_solomono['2'], 'analysis');
            $template->set ('solomomo-anchors', $res_solomono['3'], 'analysis');
            $template->set ('solomomo-anchors-out', $res_solomono['4'], 'analysis');
            $template->set ('solomomo-igood', str_replace ("/", " из ", $res_solomono['5']), 'analysis');
            $template->set ('solomomo-hin', $res_solomono['6'], 'analysis');
            $template->set ('solomomo-din', $res_solomono['7'], 'analysis');
            $template->set ('solomomo-hout', $res_solomono['8'], 'analysis');
        }

        if ($config['mod_headers_allow'] == 1 AND $_RESULT['headers'] != false) {
            $template->set_block ('headers', '', 'analysis');
            $template->set ('domain-headers', $_RESULT['headers'], 'analysis');
        }

        if ($config['mod_dns_allow'] == 1 AND $_RESULT['dns'] != false) {
            $res_dns = json_decode ($_RESULT['dns'], true);

            if (is_array ($res_dns) AND !empty ($res_dns)) {
                $domain_dns = "";
                $entries = array ('host', 'type', 'class', 'ttl', 'entries', 'pri', 'minimum-ttl');

                foreach ($res_dns as $k => $val) {
                    $extra = "";

                    $domain_dns .= "<tr>";
                    $domain_dns .= "<td>{$val['host']}</td>";
                    $domain_dns .= "<td>{$val['type']}</td>";
                    $domain_dns .= "<td>{$val['ttl']}</td>";

                    foreach ($val as $k2 => $val2) {
                        if (!in_array ($k2, $entries)) {
                            $k2 = ucfirst ($k2);
                            $k2 = str_replace (array ('Ip', 'Mname', 'Rname', 'Txt'), array ('IP', 'MNAME', 'RNAME', 'TXT'), $k2);
                            $extra .= "<strong>{$k2}</strong>: $val2<br>";
                        }
                    }

                    $domain_dns .= "<td>{$extra}</td>";
                    $domain_dns .= "</tr>";
                }

                $template->set_block ('dns', '', 'analysis');
                $template->set ('domain-dns', $domain_dns, 'analysis');
            }

        }

        if ($config['mod_maj_allow'] == 1) {
            $template->set_block ('majesticseo', '', 'analysis');
        }

        if ($config['mod_links_allow'] == 1 AND $_RESULT['site_links_num'] != false) {
            $site_links = json_decode ($_RESULT['site_links_num'], true) ;

            $scripts['links'] = file_get_contents (ENGINE_DIR . "/libs/js/links_chart.js");
            $scripts['links'] = str_replace ("{int_links_num}", $site_links['int'], $scripts['links']);
            $scripts['links'] = str_replace ("{ext_links_num}", $site_links['ext'], $scripts['links']);

            $template->set_block ('site-links', '', 'analysis');
            $template->set ('internal-links', $link_int, 'analysis');
            $template->set ('external-links', $link_ext, 'analysis');
            $template->set ('int-links-num', $site_links['int'], 'analysis');
            $template->set ('ext-links-num', $site_links['ext'], 'analysis');
            $template->set ('int-links-rel-num', $site_links['int'] - $site_links['int-rel'], 'analysis');
            $template->set ('ext-links-rel-num', $site_links['ext'] - $site_links['ext-rel'], 'analysis');
        }

        if ($config['mod_monitor_allow'] == 1 AND $_RESULT['monitor_server'] != false) {
            $stat_counter = json_decode ($_RESULT['monitor_counter'], true);

            $counter_res = array (
            	'analytics' => array ('img' => 'googleanalytics.png', 'title' => 'Google Analytics'),
            	'metrica' => array ('img' => 'yandexmetrika.png', 'title' => 'Яндекс.Метрика'),
            	'li' => array ('img' => 'li.png', 'title' => 'LiveInternet'),
            	'openstat' => array ('img' => 'openstat.png', 'title' => 'Openstat')
            );

            $counters = "";
            foreach ($stat_counter as $k => $val) {
                if ($val == true) {
                	$counters .= '<p><img class="counter-icon" src="templates/' . $config['template_name'] . '/img/counters/' . $counter_res[$k]['img'] . '" alt="' . $counter_res[$k]['title'] . '">' . $counter_res[$k]['title'] . '</p>';
                }
            }

            $server = json_decode ($_RESULT['monitor_server'], true);
            $server_data = '<p>Код ответа <span class="textright">' . $server['http_code'] . '</p>';

            if ($server['server'] == true) {
                $server_data .= '<p>Веб-сервер <span class="textright"><img class="counter-icon" src="templates/' . $config['template_name'] . '/img/counters/' . $server['server'][0] . '.png" alt="' . $server['server'][1] . '">' . $server['server'][1] . '</span></p>';
            }

            if ($server['rowered'] == true) {
                $server_data .= '<p>Язык программирования <span class="textright"><img class="counter-icon" src="templates/' . $config['template_name'] . '/img/counters/' . $server['rowered'][0] . '.png" alt="' . $server['rowered'][1] . '">' . $server['rowered'][1] . '</span></p>';
            }

            $template->set_block ('monitoring', '', 'analysis');
            if (!empty ($counters)) {
                $template->set_block ('counters', '', 'analysis');
                $template->set ('counters', $counters, 'analysis');
            }
            if (!empty ($server_data)) {
                $template->set_block ('server', '', 'analysis');
                $template->set ('server', $server_data, 'analysis');
            }
        }

        if ($config['mod_country_allow'] == 1 AND $_RESULT['country_alexa'] != false) {
            $top_country_alexa = json_decode ($_RESULT['country_alexa'], true);

            if (is_array ($top_country_alexa) AND !empty ($top_country_alexa)) {

                if ($config['mod_country_type'] == 1) {

                    $country_alexa = "";
                    foreach ($top_country_alexa as $link => $stat){
                        $country_alexa .= '<tr>
                            <td><img src="templates/' . $config['template_name'] . '/img/flags/' . $stat["code"] . '.png" alt="">' . $stat["country"] . '</td>
                            <td>' . $stat["percent"] . '</td>
                        </tr>';
                    }

                    $template->set_block ('alexa-country', '', 'analysis');
                    $template->set ('country-list', $country_alexa, 'analysis');

                } elseif ($config['mod_country_type'] == 2) {

                    $country_alexa = array ();
                    foreach ($top_country_alexa as $link => $stat) {
                        $country_alexa[] = '{name: "' . trim ($stat["country"]) . '", y: ' . intval ($stat["percent"]) . '}';
                    }

                    $scripts['country'] = file_get_contents (ENGINE_DIR . "/libs/js/country_pie.js");
                    $scripts['country'] = str_replace ("{country}", implode (", ", $country_alexa), $scripts['country']);

                    $template->set_block ('alexa-country-pie', '', 'analysis');

                }
            }
        }

        $template->set ('script', implode ("\n\r", $scripts), 'analysis');

        if ($_SESSION['request _type'] == "ajax") {

            echo $template->compile ('analysis', true);

        } else {

            $template->set ('analysis-form', $analysis_form, 'analysis');
            $content = $template->compile ('analysis', true);

        }

        $template->clear ('analysis');

    } catch (Exception $ex) {

        if ($_SESSION['request _type'] == "ajax") {

            echo message_box ("Ошибка<br>", $ex->getMessage(), 1, 1);

        } else {

            $infomessage = message_box ("Ошибка<br>", $ex->getMessage(), 1, 1);

        }

    }

    if ($_SESSION['request _type'] == "ajax") {
        unset ($_SESSION['request _type']);
        die ();
    }
}
?>