<?php
session_start ();
header ("Cache-Control: no-store, no-cache, must-revalidate");
header ("Cache-Control: post-check=0, pre-check=0", false);
header ("Pragma: no-cache");

define ('ANL', true);
define ('ROOT_DIR', "..");
define ('ENGINE_DIR', ROOT_DIR . '/modules' );
define ('CONFIG_DIR', ROOT_DIR . '/config' );

require_once CONFIG_DIR . '/dbconfig.php';
require_once CONFIG_DIR . '/settings.php';

$version_id = $config['version_id'];
$new_version = "1.9";

$result = "Для обновления скрипта, вам необходимо ввести логин и пароль.";

$login_panel = <<<HTML
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset={$config['charset']}" />
        <meta name="description" content="Reflect Template" />
		<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
        <title>Анализатор</title>
        <link rel="stylesheet" href="../modules/admin/skin/css/style_all.css" type="text/css" media="screen" />
        <!--Internet Explorer Trancparency fix-->
        <!--[if IE 6]>
        <script src="{theme}/js/ie6pngfix.js"></script>
        <script>
          DD_belatedPNG.fix('#head, a, a span, img, .message p, .click_to_close, .ie6fix');
        </script>
        <![endif]-->
    </head>
    <body class="nobackground">
        <div id="login">
            <h2 class="loginheading">Панель обновления</h2>
            <div class="icon_login ie6fix"></div>
        	<form name="login" action="" method="post" id="login-form">
            <input type="hidden" name="action" value="dologin">
            <p>
            	<label for="name">Логин</label>
            	<input class="input-medium" type="text" value="" name="login_name" id="name"/>
        	</p>
        	<p>
            	<label for="password">Пароль</label>
            	<input class="input-medium" type="password" value="" name="login_password" id="password"/>
        	</p>
        	<p class="clearboth">
                <button name="login" type="submit" value="submit" class="button">Вход</button>
        	</p>
            </form>
        </div>
        <div class="login_message message error">
          <p>{result}</p>
        </div>
    </body>
</html>
HTML;

$is_logged = false;

if (isset ($_SESSION['login_name']) AND $_SESSION['login_name'] != "") {

	$login_name = $db->real_escape_string (trim (strip_tags ($_SESSION['login_name'])));
	$login_password = $db->real_escape_string (trim (strip_tags ($_SESSION['login_password'])));

	$result = $db->query ("SELECT login, password FROM analiz_users WHERE login='$login_name' AND password='$login_password'") or die ($db->error);

	if ($result->num_rows > 0){
		$member_id = $result->fetch_assoc ();
		$is_logged = true;
	}

}

if (isset ($_POST['action']) AND $_POST['action'] == "dologin") {

	$login_name = $db->real_escape_string (trim (strip_tags ($_POST['login_name'])));
	$login_password = md5 (md5 ($_POST['login_password']));

	$result = $db->query ("SELECT login, password FROM analiz_users WHERE login='$login_name' AND password='$login_password'") or die ($db->error);

	if ($result->num_rows > 0){

        $member_id = $result->fetch_assoc ();

	    $_SESSION['login_name'] = $member_id['login'];
	    $_SESSION['login_password'] = $login_password;

	    $is_logged = true;

	} else $result = "<font color=red>Неверно введены даннные для входа!</font>";

}

if (!$is_logged) {
	$login_panel = str_replace ("{result}", $result, $login_panel);
	echo $login_panel;
	exit ();
}

$stop = "";

if (!is_writable (CONFIG_DIR.'/settings.php')){
	$stop .= "Установите права для записи на файл 'config/settings.php' CHMOD 666<br>";
}

if (!is_writable(CONFIG_DIR.'/dbconfig.php')){
	$stop .= "Установите права для записи на файл 'config/dbconfig.php' CHMOD 666<br>";
}

if ($stop == false) {

    if (isset ($_GET['next']) AND $_GET['next'] == "start") {

        switch ($version_id) {

            case $new_version :
                $content = "Обновление скрипта до актуальной версии <b>$new_version</b> было успешно завершено. Обязательно удалите папку <b>/upgrade/</b> с вашего сервера.<br><br>";
                $content = "<a href='/'>Перейти на сайт</a>";
            break;

            case "1.8" :
                include dirname (__FILE__) . '/1.8.php';
            break;

            case "1.7" :
                include dirname (__FILE__) . '/1.7.php';
            break;

            case "1.6" :
                include dirname (__FILE__) . '/1.6.php';
            break;

            case "1.5" :
                include dirname (__FILE__) . '/1.5.php';
            break;

            case "1.4" :
                include dirname (__FILE__) . '/1.4.php';
            break;

            case "1.3" :
                include dirname (__FILE__) . '/1.3.php';
            break;

            case "1.2" :
                include dirname (__FILE__) . '/1.2.php';
            break;

            case "1.1" :
            	include dirname (__FILE__) . '/1.1.php';
            break;

            case "1.0" :
            	include dirname (__FILE__) . '/1.0.php';
            break;

            default:
            	$content = "Не удалось определить установленную версию скрипта. Установка обновления остановлена.";
            break;
        }

    } else {

    	$content =  "<p><b class=\"red\">Внимание:</b> Прежде чем приступить к процедуре обновления скрипта и базы данных, убедитесь что вы создали и сохранили у себя полные бекапы файлов скрипта и базы данных.</p>";
        $content .= "<p>Текущая версия скрипта: <b>{$version_id}</b>, обновление будет пошагово произведено до версии: <b>{$new_version}</b></p>";
        $content .= "<p><form method='get'><input type='hidden' name='next' value='start'><input type='submit' value='Начать обновление'></form></p>";

    }

} else {

    $content = $stop;

}

echo <<<HTML
<!DOCTYPE html>
<html lang="ru">
<head>
  <meta charset="utf-8">
  <title>Анализатор - Обновление</title>
</head>
<style>
    body { margin: 0; padding: 0; font-size: 16px; color: #424242; font-family: Arial, Helvetica, sans-serif; line-height: 20px; min-height: 100%; position: relative;}
    h1, h2, h3, h4, h5, h6 {font-family: 'Cuprum', sans-serif; font-weight: normal;}
    a:link, a:active, a:visited, a:hover {color:#000;text-decoration:none;}
    h1 {font-size:26px}
    h4 {font-size:24px}
    h5 {font-size:20px}
    table {border-collapse: collapse; border: 1px dotted #D5D5D5;}
    td {padding:5px; text-align: center; border: 1px dotted #D5D5D5; font-size: 13px; color: #878787;}
    td:first-child {border-left: none;}
    tr { border: 1px dotted #e7e7e7; }
    tr:nth-child(even) {background-color:#f5f5f5;}
    p.error {color:red;}
    div.maindiv {width: 700px; height: auto; position: relative; left: 50%; top: 100px; margin-left: -350px; padding:20px; border:1px solid #ccc; -webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;}
    input[type=submit] {font-size: 14px; font-weight: bold; text-transform: uppercase; padding: 5px 14px 6px 14px; cursor: pointer; font-family: Arial, Helvetica, sans-serif; line-height: 12px;}
    input[type=text], input[type=password] {background: #fff; width: 97%; border: 1px solid #d5d5d5; padding: 5px; font-size: 13px; font-family: Arial, Helvetica, sans-serif; }
    .red { color: #ff2400; }
    .green { color: #2a8827; }
    .info {font-size: 12px;}
    .button {font-size: 14px; font-weight: bold; text-transform: uppercase; padding: 5px 14px 6px 14px; cursor: pointer; font-family: Arial, Helvetica, sans-serif; border: 1px solid #d5d5d5;}
</style>
<body>
<div style='width:100%; height:100%;'>
  <div class="maindiv">
    <h1>Анализатор - Мастер обновления</h1>
    $content
  </div>
</div>
</body>
</html>
HTML;
?>